BEGIN {
  switch (mode) {
  case "check":
    break;
  case "change":
    break;
  default:
    print "Case-Brace.awk: mode is not correct";
    print "it should be \"check\" or \"change\"";
    exit;
  }

  normalLine             = 0;
  comment_1_BeginIsFound = 1;
  comment_1_EndIsFound   = 2;
  comment_2_BeginIsFound = 3;
  string_1_BeginIsFound  = 4;
  string_1_EndIsFound    = 5;
  string_2_BeginIsFound  = 6;
  string_2_EndIsFound    = 7;
  directiveBeginIsFound  = 8;
  directiveEndIsFound    = 9;

  leftBrace  = "{";
  rightBrace = "}";

  # S_switchState may takes one of the next values
  S_normalLine        = 10;
  S_switchIsFound     = 11;
  S_caseIsFound       = 12; # after we must look for colon
  S_defaultIsFound    = 13; # after we must look for colon
  S_leftBraceIsFound  = 14;
  S_endOfBlockIsFound = 15;
  S_colonIsFound      = 16;

  switchState = normalLine;
  S_switchState = S_normalLine;
  braceCount = 0;
  keepTheLine = "no";
  keepTheNR = 0;
  theLineToKeep = "";
  newBlockFound = "no";
  endOfBlockIsFound = "no";

  #testIt ="yes";
  #testItCB ="yes";
} # end of BEGIN

function FirstAwayTrim(inLine,    t1, outLine)
{                            # separate local variables from real
                             # parameters  by  extra  spaces
  t1 = FirstSpaceAway(inLine);
  outLine = TrimLine(t1);
  return outLine;
}

function FirstNoSpace(inLine,    i, lengthOfTheInLine, character, firstPLace)
{                            # separate local variables from real
                             # parameters  by  extra  spaces
  # looking for first not space character
  lengthOfTheInLine = length(inLine);
  for (i = 1; i <= lengthOfTheInLine; i++) {
    character = substr(inLine, i, 1);
    if (character != " ") {
      firstPLace = i;
      break;
    }
  }
  return firstPLace;
}

function FirstSpaceAway(inLine,    outLine, firstPLace)
{                            # separate local variables from real
                             # parameters  by  extra  spaces
  # looking for first not space character
  firstPLace = FirstNoSpace(inLine);
  outLine = substr(inLine, firstPLace);
  return outLine;
}

function RIndex(inLine,whatChar,    i, lengthOfTheInLine, character, lastPLace)
{                            # separate local variables from real
                             # parameters  by  extra  spaces
  # looking for first "whatChar" character back from the end of the string "inLine"
  lengthOfTheInLine = length(inLine);
  if (lengthOfTheInLine == 0) {
    return 0;
  }
  lastPlace = 0;
  for (i = lengthOfTheInLine; i >= 1; i--) {
    character = substr(inLine, i, 1);
    if (character == whatChar) {
      lastPlace = i;
      break;
    }
  }
  return lastPlace;
}

function LookForColon(inLine,      lengthOfTheInLine, character, whereIsColon)
{                            # separate local variables from real
                             # parameters  by  extra  spaces
  # look for colon[4]
  if (testItCB == "yes") {
    printf("(105) %d: look for colon[4]\n", NR);
  }
  lengthOfTheInLine = length(inLine);
  if (lengthOfTheInLine == 0) {
    return 0;
  }
  character = substr(inLine, lengthOfTheInLine, 1);
  if (character == ":") {
    return lengthOfTheInLine;
  } else {
    if (testIt == "yes") {
      printf("look back to the :\n");
    }
    # look back to the :
    whereIsColon = RIndex(inLine, ":");
    if (whereIsColon > 0) {
      return whereIsColon;
    } else {
      return 0;
    }
  }
}

function CountBraces(inLine,      lengthOfTheInLine, character, i)
{                            # separate local variables from real
                             # parameters  by  extra  spaces
  lengthOfTheInLine = length(inLine);
  i = 1;
  while (i <= lengthOfTheInLine) {
    character = substr(inLine, i, 1);
    switch (character) {
    case "{":
      braceCount = braceCount + 1;
      if (testItCB == "yes") {
        printf("(139) %d: braceCount up to %d\n", NR, braceCount);
      }
      break;
    case "}":
      braceCount = braceCount - 1;
      if (testItCB == "yes") {
        printf("(145) %d: braceCount down to %d\n", NR, braceCount);
      }
      break;
    default:
      break;
    }
    i = i + 1;
  }
}

function TrimLine(inLine,    lengthOfInLine, letter, tempBuffer)
{                            # separate local variables from real
                             # parameters  by  extra  spaces
  # remove space(s) at end of the line
  lengthOfInLine = length(inLine);
  letter = substr(inLine, lengthOfInLine, 1);
  while (letter == " ") {
    tempBuffer = substr(inLine, 1, lengthOfInLine - 1);
    inLine = tempBuffer;
    lengthOfInLine = length(inLine);
    letter = substr(inLine, lengthOfInLine, 1);
  }
  return inLine;
}

function LookForSwitch(LineNummer)
{
  # look for switch[1]
  if (testItCB == "yes") {
    printf("(174) %d: look for switch[1], from %d\n", NR, LineNummer);
  }
  whereIsSwitch = index(theOutLine, "switch ");
  if (whereIsSwitch == 1) {
    if (testItCB == "yes") {
      printf("(179) %d: switch found[1]\n", NR);
    }
    whereIsSwitchORI = FirstNoSpace(theLine);
    if (testItCB == "yes") {
      printf("(183) %d: whereIsSwitchORI= %d\n", NR, whereIsSwitchORI);
    }
    braceCount = braceCount + 1;
    if (testItCB == "yes") {
      printf("(187) %d: braceCount up to %d\n", NR, braceCount);
    }
    switch (mode) {
    case "check":
      break;
    case "change":
      if (keepTheLine == "yes") {
        # we have a keeped line
        if (testItCB == "yes") {
          printf("(196) %d: we have a keeped line\n", keepTheNR);
          printf("(197) %d>>", keepTheNR);
        }
        printf("%s\n", theLineToKeep);
        keepTheLine = "no";
        if (testItCB == "yes") {
          printf("(202) %d: keepTheLine set to >%s<\n", NR, keepTheLine);
        }
      }
      if (testItCB == "yes") {
        printf("(206) %d>>", NR);
      }
      printf("%s\n", theLine);
      break;
    }
    S_switchState = S_switchIsFound;
    if (testItCB == "yes") {
      printf("(213) %d: S_switchState changed to S_switchIsFound\n", NR);
    }
    what = "yes";
  } else {
    switch (mode) {
    case "check":
      break;
    case "change":
      if (keepTheLine == "yes") {
        # we have a keeped line
        if (testItCB == "yes") {
          printf("(224) %d: we have a keeped line\n", keepTheNR);
          printf("(225) %d>>", keepTheNR);
        }
        printf("%s\n", theLineToKeep);
        keepTheLine = "no";
        if (testItCB == "yes") {
          printf("(230) %d: keepTheLine set to >%s<\n", NR, keepTheLine);
        }
      }
      if (testItCB == "yes") {
        printf("(234) %d>>", NR);
      }
      printf("%s\n", theLine);
      break;
    }
    what = "no";
  }
  lengthOfTheRest = 0;
  return what;
}

function LookForCase(LineNummer)
{
  # look for case[2]
  if (testItCB == "yes") {
    printf("(249) %d: look for case[2], from %d\n", NR, LineNummer);
  }
  whereIsCase = index(theOutLine, "case ");
  if (whereIsCase == 1) {
    endOfBlockIsFound = "no";
    whereIsCaseDefault = index(workLine, "case ");
    if (testItCB == "yes") {
      printf("(256) %d: case found[2]\n", NR);
    }
    whereIsCaseORI = FirstNoSpace(theLine);
    if (testItCB == "yes") {
      printf("(260) %d: whereIsCaseORI= %d\n", NR, whereIsCaseORI);
    }
    switch (mode) {
    case "check":
      if (whereIsSwitchORI != whereIsCaseORI) {
        if (testItCB == "yes") {
          printf("(266) ");
        }
        printf("%d: %s\n", NR, theLine);
        if (testItCB == "yes") {
          printf("(270) ");
        }
        printf("%d: switch(%d) and case(%d) should have the same indentation\n",
               NR, whereIsSwitchORI, whereIsCaseORI);
      }
      break;
    case "change":
      break;
    }
    S_switchState = S_caseIsFound;
    if (testItCB == "yes") {
      printf("(281) %d: S_switchState changed to S_caseIsFound\n", NR);
    }
    temp = substr(theOutLine, 6);
    if (testItCB == "yes") {
      printf("(285) %d: temp >%s<\n", NR, temp);
    }
    theOutLine = temp; 
    lengthOfTheRest = length(theOutLine);
    what = "yes";
  } else {
    what = "no";
  }
  return what;
}

function LookForDefault(LineNummer)
{
  # look for default[3]
  if (testItCB == "yes") {
    printf("(300) %d: look for default[3], from %d\n", NR, LineNummer);
  }
  whereIsDefault = index(theOutLine, "default:");
  if (whereIsDefault == 1) {
    endOfBlockIsFound = "no";
    if ( testItCB == "yes") {
      printf("(306) %d: default found[3]\n", NR);
    }
    whereIsDefaultORI = index(theLine, "default:");
    switch (mode) {
    case "check":
      if (whereIsSwitchORI != whereIsDefaultORI) {
        if (testItCB == "yes") {
          printf("(313) ");
        }
        printf("%d: %s\n", NR, theLine);
        if (testItCB == "yes") {
          printf("(317) ");
        }
        printf("%d: switch(%d) and default(%d) should have the same indentation\n",
               NR, whereIsSwitchORI, whereIsDefaultORI);
      }
      break;
    case "change":
      break;
    }
    S_switchState = S_defaultIsFound;
    if (testItCB == "yes") {
      printf("(328) %d: S_switchState changed to S_defaultIsFound\n", NR);
    }
    temp = substr(theOutLine, 8);
    if (testItCB == "yes") {
      printf("(332) %d: temp >%s<\n", NR, temp);
    }
    theOutLine = temp; 
    lengthOfTheRest = length(theOutLine);
    what = "yes";
  } else {
    what = "no";
  }
  return what;
}

function LookForBreak(LineNummer)
{
  # look for break[5]
  if (testItCB == "yes") {
    printf("(347) %d: look for break[5], from %d\n", NR, LineNummer);
  }
  whereIsBreak = index(theOutLine, "break");
  if (whereIsBreak == 1) {
    if (testItCB == "yes") {
      printf("(352) %d: break found[5] ...\n", NR);
      printf("(353) %d: braceCount >%d<\n", NR, braceCount);
      printf("(354) %d: endOfBlockIsFound >%s<\n", NR, endOfBlockIsFound);
    } 
    if (braceCount == 1) {
      # break with braceCount is 1, ... without any block
      if (endOfBlockIsFound == "yes") {
        # we had a new block
        # break with braceCount is 1, after a new block
        if (testItCB == "yes") {
          printf("(362) %d: break found[5], after a new block\n", NR);
        }
        switch (mode) {
        case "check":
          if (testItCB == "yes") {
            printf("(367) ");
          }
          printf("%d: %s\n", NR, theLine);
          if (testItCB == "yes") {
            printf("(371) ");
          }
          printf("%d: break should be placed before the end of the block\n", NR);
          break;
        case "change":
          if (testItCB == "yes") {
            printf("(377) %d>>", NR);
          }
          # intendation one more
          printf("    %s\n", theLine);
          if (testItCB == "yes") {
            printf("(382) %d: keepTheLine is >%s<\n", NR, keepTheLine);
          }
          if (keepTheLine == "yes") {
            # we have a keeped line
            if (testItCB == "yes") {
              printf("(387) %d: we have a keeped line\n", keepTheNR);
              printf("(388) %d>>", keepTheNR);
            }
            printf("%s\n", theLineToKeep);
            keepTheLine = "no";
            if (testItCB == "yes") {
              printf("(393) %d: keepTheLine set to >%s<\n", NR, keepTheLine);
            }
          }
          break;
        }
      } else {
        if (testItCB == "yes") {
          printf("(400) %d: break found[5], without any new block\n", NR);
        }
        switch (mode) {
        case "check":
          break;
        case "change":
          if (keepTheLine == "yes") {
            # we have a keeped line
            if (testItCB == "yes") {
              printf("(409) %d: we have a keeped line\n", keepTheNR);
              printf("(410) %d>>", keepTheNR);
            }
            printf("%s\n", theLineToKeep);
            if (testItCB == "yes") {
              printf("(414) %d>>", NR);
            }
            printf("%s\n", theLine);
            keepTheLine = "no";
            if (testItCB == "yes") {
              printf("(419) %d: keepTheLine set to >%s<\n", NR, keepTheLine);
            }
          } else {
            if (testItCB == "yes") {
              printf("(423) %d>>", NR);
            }
            printf("%s\n", theLine);
          }
          break;
        }
      }
    } else {
      # break with braceCount is > 1, within the new block
      if (testItCB == "yes") {
        printf("(433) %d: break found within the new block\n", NR);
      }
      switch (mode) {
      case "check":
        break;
      case "change":
        if (keepTheLine == "yes") {
          # we have a keeped line
          if (testItCB == "yes") {
            printf("(442) %d: we have a keeped line\n", keepTheNR);
            printf("(443) %d>>", keepTheNR);
          }
          printf("%s\n", theLineToKeep);
          keepTheLine = "no";
          if (testItCB == "yes") {
            printf("(448) %d: keepTheLine set to >%s<\n", NR, keepTheLine);
          }
        }
        if (testItCB == "yes") {
          printf("(452) %d: keepTheLine is >%s<\n", NR, keepTheLine);
        }
        if (testItCB == "yes") {
          printf("(455) %d>>", NR);
        }
        printf("%s\n", theLine);
        break;
      }
      endOfBlockIsFound = "no";
    }
    S_switchState = S_switchIsFound;
    if (testItCB == "yes") {
      printf("(464) %d: S_switchState changed to S_switchIsFound\n", NR);
    }
    lengthOfTheRest = 0;
    what = "yes";
  } else {
    what = "no";
  }
  return what;
}

function LookForReturn(LineNummer)
{
  # look for return[6]
  if (testItCB == "yes") {
    printf("(478) %d: look for return[6], from %d\n", NR, LineNummer);
  }
  whereIsReturn = index(theOutLine, "return");
  if (testItCB == "yes") {
    printf("(482) %d: braceCount= %d\n", NR, braceCount);
    printf("(483) %d: endOfBlockIsFound is >%s<\n", NR, endOfBlockIsFound);
  }
  if (whereIsReturn == 1) {
    if (testItCB == "yes") {
      printf("(487) %d: return found[6] ...\n", NR);
    }
    if (braceCount == 1) {
      # return with braceCount is 1, ... without any block
      if (endOfBlockIsFound == "yes") {
        # we had a new block
        # return with braceCount is 1, after a new block
        if (testItCB == "yes") {
          printf("(495) %d: return found, after a new block\n", NR);
        }
        switch (mode) {
        case "check":
          if (testItCB == "yes") {
            printf("(500) ");
          }
          printf("%d: %s\n", NR, theLine);
          if (testItCB == "yes") {
            printf("(504) ");
          }
          printf("%d: return should be placed before the end of the block\n", NR);
          break;
        case "change":
         if (keepTheLine == "yes") {
            if (testItCB == "yes") {
              printf("(511) %d>>", NR);
            }
            # intendation one more
            printf("    %s\n", theLine);
            # we have a keeped line
            if (testItCB == "yes") {
              printf("(517) %d: we have a keeped line\n", keepTheNR);
              printf("(518) %d>>", keepTheNR);
            }
            printf("%s\n", theLineToKeep);
            keepTheLine = "no";
            if (testItCB == "yes") {
              printf("(523) %d: keepTheLine set to >%s<\n", NR, keepTheLine);
            }
          }
          break;
        }
     } else {
        if (testItCB == "yes") {
          printf("(530) %d: return found[6], without any new block\n", NR);
        }
        switch (mode) {
        case "check":
          break;
        case "change":
          if (keepTheLine == "yes") {
            # we have a keeped line
            if (testItCB == "yes") {
              printf("(539) %d: we have a keeped line\n", keepTheNR);
              printf("(540) %d>>", keepTheNR);
            }
            printf("%s\n", theLineToKeep);
            if (testItCB == "yes") {
              printf("(544) %d>>", NR);
            }
            printf("%s\n", theLine);
            keepTheLine = "no";
          } else {
            if (testItCB == "yes") {
              printf("(550) %d>>", NR);
            }
            printf("%s\n", theLine);
          }
          break;
        }
      }
    } else {
      # return with braceCount is > 1, within the new block
      if (testItCB == "yes") {
        printf("(560) %d: return found within the new block\n", NR);
      }
      switch (mode) {
      case "check":
        break;
      case "change":
        if (keepTheLine == "yes") {
          # we have a keeped line
          if (testItCB == "yes") {
            printf("(569) %d: we have a keeped line\n", keepTheNR);
            printf("(570) %d>>", keepTheNR);
          }
          printf("%s\n", theLineToKeep);
          keepTheLine = "no";
          if (testItCB == "yes") {
            printf("(575) %d: keepTheLine set to >%s<\n", NR, keepTheLine);
          }
        }
        if (testItCB == "yes") {
          printf("(579) %d: keepTheLine is >%s<\n", NR, keepTheLine);
        }
        if (testItCB == "yes") {
          printf("(582) %d>>", NR);
        }
        printf("%s\n", theLine);
        break;
      }
      endOfBlockIsFound = "no";
    }
    S_switchState = S_switchIsFound;
    if (testItCB == "yes") {
      printf("(591) %d: S_switchState changed to S_switchIsFound\n", NR);
    }
    lengthOfTheRest = 0;
    what = "yes";
  } else {
    what = "no";
  }
  return what;
}

function LookForLeftBrace(LineNummer)
{
  # look for leftBrace[7]
  if (testItCB == "yes") {
    printf("(605) %d: look for leftBrace[7], from %d\n", NR, LineNummer);
  }
  whereIsLeftBrace = index(theOutLine, leftBrace);
  if (whereIsLeftBrace == 1) {
    if (testItCB == "yes") {
      printf("(610) %d: leftBrace found[7]\n", NR);
    }
    braceCount = braceCount + 1;
    if (testItCB == "yes") {
      printf("(614) %d: braceCount up to %d\n", NR, braceCount);
    }
    switch (mode) {
    case "check":
      break;
    case "change":
      if (keepTheLine == "yes") {
        lengthOfWorkLineToKeep = length(workLineToKeep);
        secondPart = substr(theLineToKeep, lengthOfWorkLineToKeep + 1);
        # we have a keeped line
        if (testItCB == "yes") {
          printf("(625) %d: workLineToKeep  >%s<\n", NR, workLineToKeep);
          printf("(626) %d: lengthOfWorkLineToKeep= %d\n", NR, lengthOfWorkLineToKeep);
          printf("(627) %d: secondPart >%s<\n", NR, secondPart);
          printf("(628) %d: we have a keeped line\n", keepTheNR);
          printf("(629) %d>>", keepTheNR);
        }
        if (oneLineCaseBrace == "yes") {
          printf("%s\n", theLineToKeep);
        } else {
          printf("%s %s %s\n", workLineToKeep, leftBrace, secondPart);
        }
        keepTheLine = "no";
        if (testItCB == "yes") {
          printf("(638) %d: keepTheLine set to >%s<\n", NR, keepTheLine);
        }
      } else {
        if (testItCB == "yes") {
          printf("(642) %d>>", NR);
        }
        printf("%s\n", theLine);
      }
      break;
    }
    S_switchState = S_leftBraceIsFound;
    if (testItCB == "yes") {
      printf("(650) %d: S_switchState changed to S_leftBraceIsFound\n", NR);
    }
    newBlockFound = "yes";
    if (testItCB == "yes") {
      printf("(654) %d: newBlockFound changed to >yes<\n", NR);
    }
    lengthOfTheRest = 0;
    what = "yes";
  } else {
    what = "no";
  }
  return what;
}

function LookForRightBrace(LineNummer)
{
  # look for rightBrace[12]
  if (testItCB == "yes") {
    printf("(668) %d: look for rightBrace[12], from %d\n", NR, LineNummer);
  }
  whereIsRightBrace = index(theOutLine, rightBrace);
  if (whereIsRightBrace == 1) {
    if (testItCB == "yes") {
      printf("(673) %d: rightBrace found[12]\n", NR);
    }
    braceCount = braceCount - 1;
    if (testItCB == "yes") {
      printf("(677) %d: braceCount down to %d\n", NR, braceCount);
    }
    if (braceCount == 1) {
      switch (mode) {
      case "check":
        break;
      case "change":
        if (keepTheLine == "yes") {
          # we have a keeped line
          if (testItCB == "yes") {
            printf("(687) %d: we have a keeped line\n", keepTheNR);
            printf("(688) %d>>", keepTheNR);
          }
          printf("%s\n", theLineToKeep);
          keepTheLine = "no"; 
          if (testItCB == "yes") {
            printf("(693) %d: keepTheLine set to >%s<\n", NR, keepTheLine);
          }
        }
        # keep the line
        keepTheLine = "yes";
        if (testItCB == "yes") {
          printf("(699) %d: keepTheLine set to >%s<\n", NR, keepTheLine);
        }
        keepTheNR = NR;
        theLineToKeep = theLine;
        if (testItCB == "yes") {
          printf("(704) %d: keep the line >%s<\n", NR, theLine);
        }
        break;
      }
      if (testItCB == "yes") {
        printf("(709) %d: newBlockFound is >%s<\n", NR, newBlockFound);
      }
      if(newBlockFound == "yes") {
        endOfBlockIsFound = "yes";
        if (testItCB == "yes") {
          printf("(714) %d: endOfBlockIsFound set to >yes<\n", NR);
        }
        newBlockFound = "no";
        if (testItCB == "yes") {
          printf("(718) %d: newBlockFound set to >no<\n", NR);
        }
      }
      S_switchState = S_switchIsFound;
      if (testItCB == "yes") {
        printf("(723) %d: S_switchState changed to S_switchIsFound\n", NR);
      }
    } else {
      switch (mode) {
      case "check":
        break;
      case "change":
        if (testItCB == "yes") {
          printf("(731) %d>>", NR);
        }
        printf("%s\n", theLine);
        break;
      }
    }
    if (braceCount == 0) {
      if (testItCB == "yes") {
        printf("(739) %d: S_switchState changed to S_normalLine\n", NR);
      }
      S_switchState = S_normalLine;
    }
    lengthOfTheRest = 0;
    what = "yes";
  } else {
    what = "no";
  }
  return what;
}

{ # do the job
  theLine = $0;
  if (testIt == "yes") {
    printf("\n%d: ====>:%s:\n", NR, theLine);
  }
  restOfTheLine = theLine;
  lengthOfTheRest = length(restOfTheLine);
  workLine = "";

  while (lengthOfTheRest > 0) {
    if (testIt == "yes") {
      printf("switchState(762)(%d)= %d\n", NR, switchState);
      switch (switchState) {
      case 0: printf("    normalLine\n"); break;
      case 1: printf("    comment_1_BeginIsFound\n"); break;
      case 2: printf("    comment_1_EndIsFound\n"); break;
      case 3: printf("    comment_2_BeginIsFound\n"); break;
      case 4: printf("    string_1_BeginIsFound\n"); break;
      case 5: printf("    string_1_EndIsFound\n"); break;
      case 6: printf("    string_2_BeginIsFound\n"); break;
      case 7: printf("    string_2_EndIsFound\n"); break;
      case 8: printf("    directiveBeginIsFound\n"); break;
      case 9: printf("    directiveEndIsFound\n"); break;
      }
    }
    switch(switchState) {
    case 0: # normalLine
      # first dispatch comment_1/comment_2/string_1/string_2/directive
      whereIsComment_1 = index(restOfTheLine, "/*");
      whereIsComment_2 = index(restOfTheLine, "//");
      whereIsString_1 = index(restOfTheLine, "\"");
      whereIsString_2 = index(restOfTheLine, "'");
      if (testIt == "yes") {
        printf("whereIsComment_1= %d\n", whereIsComment_1);
        printf("whereIsComment_2= %d\n", whereIsComment_2);
        printf("whereIsString_1= %d\n", whereIsString_1);
        printf("whereIsString_2= %d\n", whereIsString_2);
      }
      # dispatch it
      if (whereIsComment_1 > 0) {
        # [1]
        switchState = comment_1_BeginIsFound;
        if (testIt == "yes") {
          printf("switchState(794)(%d) changed to comment_1_BeginIsFound\n", NR);
        }
        partBeforeComment = substr(restOfTheLine, 1, whereIsComment_1 - 1);
        if (testIt == "yes") {
          printf("(798)partBeforeComment >%s<\n", partBeforeComment);
        }
        workLine = workLine partBeforeComment;
        if (testIt == "yes") {
          printf("(802)workLine >%s<:\n", workLine);
        }
        temp = substr(restOfTheLine, whereIsComment_1 + 2);
        restOfTheLine = temp;
        lengthOfTheRest = length(restOfTheLine);
        if (testIt == "yes") {
          printf("%d:(808)restOfTheLine >%s<\n", NR, restOfTheLine);
        }
      } else {
        whereIsComment_2 = index(restOfTheLine, "//");
        if (testIt == "yes") {
          printf("whereIsComment_2= %d\n", whereIsComment_2);
        }
        if (whereIsComment_2 > 0) {
          # []
          switchState = comment_2_BeginIsFound;
          if (testIt == "yes") {
            printf("switchState(819)(%d) changed to comment_2_BeginIsFound\n", NR);
          }
          partBeforeComment = substr(restOfTheLine, 1, whereIsComment_2 - 1);
          # remove space(s) at end of the line
          partBefore = TrimLine(partBeforeComment);
          if (testIt == "yes") {
            printf("(825)partBeforeComment >%s<\n", partBeforeComment);
          }
          workLine = workLine partBeforeComment;
          if (testIt == "yes") {
            printf("(829)workLine >%s<:\n", workLine);
          }
        } else {
          whereIsString_1 = index(restOfTheLine, "\"");
          if (testIt == "yes") {
            printf("whereIsString_1= %d\n", whereIsString_1);
          }
          whereIsString_2 = index(restOfTheLine, "'");
          if (testIt == "yes") {
            printf("whereIsString_2= %d\n", whereIsString_2);
          }
          if ((whereIsString_1 > 0) && (whereIsString_2 > 0)) {
            if (testIt == "yes") {
              printf("choosing ...\n");
            }
            # check which one is first
            if (whereIsString_1 < whereIsString_2) {
              # whereIsString_1 is first
              whereIsString_2 = 0;
            } else {
              # whereIsString_2 is first
              whereIsString_1 = 0;
            }
          } else {
            # nothing to check
          }
          if (testIt == "yes") {
            printf("after choosing: whereIsString_1= %d\n", whereIsString_1);
          }
          if (testIt == "yes") {
            printf("after choosing: whereIsString_2= %d\n", whereIsString_2);
          }
          if (whereIsString_1 > 0) {
            # []
            switchState = string_1_BeginIsFound;
            if (testIt == "yes") {
              printf("switchState(865)(%d) changed to string_1_BeginIsFound\n", NR);
            }
            partBeforeString = substr(restOfTheLine, 1, whereIsString_1 - 1);
            if (testIt == "yes") {
              printf("(869)partBeforeString >%s<\n", partBeforeString);
            }
            workLine = workLine partBeforeString;
            if (testIt == "yes") {
              printf("(873)workLine >%s<:\n", workLine);
            }
            temp = substr(restOfTheLine, whereIsString_1 + 1);
            restOfTheLine = temp;
            lengthOfTheRest = length(restOfTheLine);
            if (testIt == "yes") {
              printf("%d:(879)restOfTheLine >%s<\n", NR, restOfTheLine);
            }
          } else {
            whereIsString_2 = index(restOfTheLine, "'");
            if (testIt == "yes") {
              printf("whereIsString_2= %d\n", whereIsString_2);
            }
            if (whereIsString_2 > 0) {
              # []
              switchState = string_2_BeginIsFound;
              if (testIt == "yes") {
                printf("switchState(890)(%d) changed to string_2_BeginIsFound\n", NR);
              }
              partBeforeString = substr(restOfTheLine, 1, whereIsString_2 - 1);
              if (testIt == "yes") {
                printf("(894)partBeforeString >%s<\n", partBeforeString);
              }
              workLine = workLine partBeforeString;
              if (testIt == "yes") {
                printf("(898)workLine >%s<:\n", workLine);
              }
              temp = substr(restOfTheLine, whereIsString_2 + 1);
              restOfTheLine = temp;
              lengthOfTheRest = length(restOfTheLine);
              if (testIt == "yes") {
                printf("%d:(904)restOfTheLine >%s<\n", NR, restOfTheLine);
              }
            } else {
              whereIsDirective = index(restOfTheLine, "#define ");
              if (testIt == "yes") {
                printf("whereIsDirective= %d\n", whereIsDirective);
              }
              if (whereIsDirective > 0) {
                # []
                switchState = directiveBeginIsFound;
                if (testIt == "yes") {
                  printf("switchState(915)(%d) changed to directiveBeginIsFound\n", NR);
                }
                temp = substr(restOfTheLine, whereIsDirective + 8);
                restOfTheLine = temp;
                lengthOfTheRest = length(restOfTheLine);
                if (testIt == "yes") {
                  printf("%d:(921)restOfTheLine >%s<\n", NR, restOfTheLine);
                }
              } else {
                # it is a normal line
                workLine = workLine restOfTheLine;
                # only for documentation: restOfTheLine = "";
                lengthOfTheRest = 0;
              }
            }
          }
        }
      }
      break;
    case 1: # comment_1_BeginIsFound
      if (testIt == "yes") {
        printf("%d:(936)restOfTheLine >%s<\n", NR, restOfTheLine);
      }
      # looking for */
      whereIsCommentEnd = index(restOfTheLine, "*/");
      if (whereIsCommentEnd > 0) {
        # [2]
        switchState = comment_1_EndIsFound;
        if (testIt == "yes") {
          printf("switchState(944)(%d) changed to comment_1_EndIsFound\n", NR);
        }
        # prepare the rest
        temp = substr(restOfTheLine, whereIsCommentEnd + 2);
        restOfTheLine = temp;
        if (testIt == "yes") {
          printf("(950)restOfTheLine >%s<\n", restOfTheLine);
        }
      } else {
        # no comment end found
        lengthOfTheRest = 0;
      }
      if (testIt == "yes") {
        printf("(957)workLine >%s<:\n", workLine);
      }
      break;
    case 2: # comment_1_EndIsFound
      if (testIt == "yes") {
        printf("(962)restOfTheLine >%s<\n", restOfTheLine);
      }
      lengthOfTheRest = length(restOfTheLine);
      switchState = normalLine;
      if (testIt == "yes") {
        printf("switchState(967)(%d) changed to normalLine\n", NR);
      }
      break;
    case 3: # comment_2_BeginIsFound
      # only for documentation: restOfTheLine = "";
      lengthOfTheRest = 0;
      switchState = normalLine;
      if (testIt == "yes") {
        printf("switchState(975)(%d) changed to normalLine\n", NR);
      }
      break;
    case 4: # string_1_BeginIsFound
      if (testIt == "yes") {
        printf("%d:(980)restOfTheLine >%s<\n", NR, restOfTheLine);
        printf("... looking for \"\n");
      }
      # looking for a closing "
      lengthOfTheRest = length(restOfTheLine);
      i = 1;
      EndIsFound = "no";
      while (i <= lengthOfTheRest && EndIsFound == "no") {
        character = substr(restOfTheLine, i, 1);
        if (testIt == "yes") {
          printf("look:i= %d: character=:%s:\n", i, character);
        }
        switch (character) {
        case "\"":
          if (testIt == "yes") {
            printf("found \"\n");
          }
            EndIsFound = "yes";
            whereIsStringEnd = i;
          break;
        case "\\":
          i = i + 1;
          if (testIt == "yes") {
            printf("found \\ escape character %d\n", i);
          }
          break;
        default:
          break;
        }
        i = i + 1;
      }
      if (testIt == "yes") {
        printf("%d:(1012)whereIsStringEnd= %d\n", NR, whereIsStringEnd);
      }
      if (whereIsStringEnd > 0) {
        # []
        switchState = string_1_EndIsFound;
        if (testIt == "yes") {
          printf("switchState(1018)(%d) changed to string_1_EndIsFound\n", NR);
        }
        # prepare the rest
        temp = substr(restOfTheLine, whereIsStringEnd + 1);
        restOfTheLine = temp;
        if (testIt == "yes") {
          printf("(1024)restOfTheLine >%s<\n", restOfTheLine);
        }
      } else {
        # no string end found
        lengthOfTheRest = 0;
      }
      if (testIt == "yes") {
        printf("(1031)workLine >%s<:\n", workLine);
      }
      break;
    case 5: # string_1_EndIsFound
      if (testIt == "yes") {
        printf("(1036)restOfTheLine >%s<\n", restOfTheLine);
      }
      lengthOfTheRest = length(restOfTheLine);
      switchState = normalLine;
      if (testIt == "yes") {
        printf("switchState(1041)(%d) changed to normalLine\n", NR);
      }
      break;
    case 6: # string_2_BeginIsFound
      if (testIt == "yes") {
        printf("%d:(1046)restOfTheLine >%s<\n", NR, restOfTheLine);
      }
      # looking for closing '
      lengthOfTheRest = length(restOfTheLine);
      i = 1;
      EndIsFound = "no";
      while (i <= lengthOfTheRest && EndIsFound == "no") {
        character = substr(restOfTheLine, i, 1);
        if (testIt == "yes") {
          printf("look:i= %d: character=:%s:\n", i, character);
        }
        switch (character) {
        case "'":
          if (testIt == "yes") {
            printf("found '\n");
          }
            EndIsFound = "yes";
            whereIsStringEnd = i;
          break;
        case "\\":
          i = i + 1;
          if (testIt == "yes") {
            printf("found \\ escape character %d\n", i);
          }
          break;
        default:
          break;
        }
        i = i + 1;
      }
      if (testIt == "yes") {
        printf("%d:(1077)whereIsStringEnd= %d\n", NR, whereIsStringEnd);
      }
      if (whereIsStringEnd > 0) {
        # []
        switchState = string_2_EndIsFound;
        if (testIt == "yes") {
          printf("switchState(1083)(%d) changed to string_2_EndIsFound\n", NR);
        }
        # prepare the rest
        temp = substr(restOfTheLine, whereIsStringEnd + 1);
        restOfTheLine = temp;
        if (testIt == "yes") {
          printf("(1089)restOfTheLine >%s<\n", restOfTheLine);
        }
      } else {
        # no string end found
        lengthOfTheRest = 0;
      }
      if (testIt == "yes") {
        printf("(1096)workLine >%s<:\n", workLine);
      }
      break;
    case 7: # string_2_EndIsFound
      if (testIt == "yes") {
        printf("(1101)restOfTheLine >%s<\n", restOfTheLine);
      }
      lengthOfTheRest = length(restOfTheLine);
      switchState = normalLine;
      if (testIt == "yes") {
        printf("switchState(1106)(%d) changed to normalLine\n", NR);
      }
      break;
    case 8: # directiveBeginIsFound
      if (testIt == "yes") {
        printf("%d:(1111)restOfTheLine >%s<\n", NR, restOfTheLine);
      }
      # looking for \ at the end of the line
      lengthOfTheRest = length(restOfTheLine);
      letter = substr(restOfTheLine, lengthOfTheRest, 1);
      if (letter != "\\") {
        # []
        switchState = directiveEndIsFound;
        if (testIt == "yes") {
          printf("switchState(1120)(%d) changed to DirectiveEndIsFound\n", NR);
        }
      } else {
        # the directive goes on on the next line
        lengthOfTheRest = 0;
      }
      break;
    case 9: # directiveEndIsFound
      lengthOfTheRest = 0;
      switchState = normalLine;
      break;
    default:
      printf("(1132) %d: WRONG VALUE for switchState= %d\n", NR, switchState);
      exit;
    } # switch(switchState)
  } # while (lengthOfTheRest > 0)
  if (testIt == "yes") {
    printf("(nach while)workLine >%s<\n", workLine);
  }

  # look for Switch... Case... Brace
  theOutLine = FirstAwayTrim(workLine);
  lengthOfTheRest = length(theOutLine);
  if (testItCB == "yes") {
    printf("\n(1144) %d: look for Switch... Case... Brace ", NR);
    printf("in the theOutLine >%s<\n", theOutLine);
    printf("(1146) %d: in the input line >%s<\n", NR, theLine);
  }

  if (lengthOfTheRest > 0) {
    while (lengthOfTheRest > 0) {
      if (testItCB == "yes") {
        printf("(1152) %d: at the beginning of while: S_switchState= ", NR);
        switch (S_switchState) {
        case 10: printf("S_normalLine\n"); break;
        case 11: printf("S_switchIsFound\n"); break;
        case 12: printf("S_caseIsFound\n"); break;
        case 13: printf("S_defaultIsFound\n"); break;
        case 14: printf("S_leftBraceIsFound\n"); break;
        case 15: printf("S_endOfBlockIsFound\n"); break;
        case 16: printf("S_colonIsFound\n"); break;
        }
        if (testItCB == "yes") {
          printf("(1163) %d:                            braceCount= %d\n", NR, braceCount);
        }
      }
      switch(S_switchState) {
      case 10: # S_normalLine:
        # look for switch[1]
        lfs = LookForSwitch(1169);
        if (lfs == "yes") {
          if (testItCB == "yes") {
            printf("(1172) %d: switch found[1]\n", NR);
          }
        } else {
          if (testItCB == "yes") {
            printf("(1176) %d: no switch found\n", NR);
          }
        }
        break;
      case 11: # S_switchIsFound
      case 16: # S_colonIsFound
        if (testItCB == "yes") {
          printf("(1183) %d: look for case[2], default[3], rightBrace[8], ", NR);
          printf("break[5], return[6], leftBrace[7], other statment(s)[12]\n");
        }
        # look for case[2]
        lfc = LookForCase(1187);
        if (lfc == "yes") {
          if (testItCB == "yes") {
            printf("(1190) %d: case found[2]\n", NR);
          }
        } else {
          if (testItCB == "yes") {
            printf("(1194) %d: no case found\n", NR);
          }
          # look for default[3]
          lfd = LookForDefault(1197);
          if (lfd == "yes") {
            if (testItCB == "yes") {
              printf("(1200) %d: default found[3]\n", NR);
            }
          } else {
            if (testItCB == "yes") {
              printf("(1204) %d: no default found\n", NR);
            }
            # look for rightBrace[]
            lfrb = LookForRightBrace(1207);
            if (lfrb == "yes") {
              if ( testItCB == "yes") {
                printf("(1210) %d: rightBrace found\n", NR);
              }
            } else {
              if (testItCB == "yes") {
                printf("(1214) %d: no rightBrace found\n", NR);
              }
              # look for break[5]
              lfb = LookForBreak(1217);
              if (lfb == "yes") {
                if ( testItCB == "yes") {
                  printf("(1220) %d: break found[5]\n", NR);
                }
              } else {
                if (testItCB == "yes") {
                  printf("(1224) %d: no break found\n", NR);
                }
                # look for return[6]
                lfr = LookForReturn(1227);
                if (lfr == "yes") {
                  if ( testItCB == "yes") {
                    printf("(1230) %d: return found[6]\n", NR);
                  }
                } else {
                  if (testItCB == "yes") {
                    printf("(1234) %d: no return found\n", NR);
                  }
                  # look for leftBrace[7]
                  lfl = LookForLeftBrace(1237);
                  if (lfl == "yes") {
                    if ( testItCB == "yes") {
                      printf("(1240) %d: leftBrace found[7]\n", NR);
                    }
                  } else {
                    if (testItCB == "yes") {
                      printf("(1244) %d: no leftBrace found\n", NR);
                    }
                    if (testItCB == "yes") {
                      printf("(1247) %d: other statment(s)[12]\n", NR);
                      printf("(1248) %d: count parenthesis and braces\n", NR);
                    }
                    # other statment(s)[12]
                    CountBraces(theOutLine);
                    if (testItCB == "yes") {
                      printf("(1253) %d: braceCount= %d\n", NR, braceCount);
                    }
                    switch (mode) {
                    case "check":
                      break;
                    case "change":
                      if (keepTheLine == "yes") {
                        # we have a keeped line
                        if (testItCB == "yes") {
                          printf("(1262) %d: we have a keeped line\n", keepTheNR);
                          printf("(1263) %d>>", keepTheNR);
                        }
                        printf("%s\n", theLineToKeep);
                        keepTheLine = "no";
                        if (testItCB == "yes") {
                          printf("(1268) %d: keepTheLine set to >%s<\n", NR, keepTheLine);
                        }
                      }
                      if (testItCB == "yes") {
                        printf("(1272) %d>>", NR);
                      }
                      printf("%s\n", theLine);
                      break;
                    }
                  }
                }
              }
            }
            lengthOfTheRest = 0;
          }
        }
        break;
      case 12: # S_caseIsFound
      case 13: # S_defaultIsFound
        # a colon must be present, check it
        # look for colon[4]
        if (testItCB == "yes") {
          printf("(1290) %d: look for colon[4]\n", NR);
          printf("(1291) %d: theOutLine >%s<\n", NR, theOutLine);
        }
        # look for colon
        whereIsColon = LookForColon(theOutLine);
        if (whereIsColon > 0) {
          if (testItCB == "yes") {
            printf("(1297) %d: Colon found at %d\n", NR, whereIsColon);
          }
          temp = substr(theOutLine, whereIsColon + 1);
          theOutLine = FirstSpaceAway(temp); 
          lengthOfTheRest = length(theOutLine);
          S_switchState = S_colonIsFound;
          if (testItCB == "yes") {
            printf("(1304) %d: S_switchState changed to S_colonIsFound\n", NR);
          }
          if (testItCB == "yes") {
            if (lengthOfTheRest == 0) {
              printf("(1308) %d: the rest theOutLine is empty\n", NR);
            } else {
              printf("(1310) %d: the rest theOutLine >%s<\n", NR, theOutLine);
            }
          }
          oneLineCaseBrace = "no";
          if (lengthOfTheRest > 0) {
            lastCharacter = substr(theOutLine, lengthOfTheRest, 1);
            if (testItCB == "yes") {
              printf("(1317) %d: lastCharacter >%s<\n", NR, lastCharacter);
            }
            if (lastCharacter == leftBrace) {
              oneLineCaseBrace = "yes";
              braceCount = braceCount + 1;
              newBlockFound = "yes";
              if (testItCB == "yes") {
                printf("(1324) %d: newBlockFound changed to >yes<\n", NR);
              }
              if (testItCB == "yes") {
                printf("(1327) %d: braceCount up to %d --> a new block\n", NR, braceCount);
              }
            }
          }
          if (testItCB == "yes") {
            printf("(1332) %d: oneLineCaseBrace set to >%s<\n", NR, oneLineCaseBrace);
              switch (mode) {
              case "check":
                break;
              case "change":
                  printf("(1337) %d: keepTheLine is >%s<\n", NR, keepTheLine);
                break;
              }
          }
          switch (mode) {
          case "check":
            break;
          case "change":
            if (keepTheLine == "yes") {
              # we have a keeped line
              if (testItCB == "yes") {
                printf("(1348) %d: we have a keeped line\n", keepTheNR);
                printf("(1349) %d>>", keepTheNR);
              }
              printf("%s\n", theLineToKeep);
              keepTheLine = "no";
              if (testItCB == "yes") {
                printf("(1354) %d: keepTheLine set to >%s<\n", NR, keepTheLine);
              }
            }
            break;
          }
          if (oneLineCaseBrace == "no") {
            switch (mode) {
            case "check":
              break;
            case "change":
              # keep the line
              workLineToKeep = TrimLine(workLine);
              if (testItCB == "yes") {
                printf("(1367) %d: keep the line >%s<\n", NR, theLine);
                printf("(1368) %d: keep the workLine >%s<\n", NR, workLineToKeep);
              }
              keepTheLine = "yes";
              if (testItCB == "yes") {
                printf("(1372) %d: keepTheLine set to >%s<\n", NR, keepTheLine);
              }
              keepTheNR = NR;
              theLineToKeep = theLine;
              break;
            }
          } else {
            switch (mode) {
            case "check":
              break;
            case "change":
              if (keepTheLine == "yes") {
                # we have a keeped line
                if (testItCB == "yes") {
                  printf("(1386) %d: we have a keeped line\n", keepTheNR);
                  printf("(1387) %d>>", keepTheNR);
                }
                printf("%s\n", theLineToKeep);
                keepTheLine = "no";
                if (testItCB == "yes") {
                  printf("(1392) %d: keepTheLine set to >%s<\n", NR, keepTheLine);
                }
              }
              if (testItCB == "yes") {
                printf("(1396) %d>>", NR);
              }
              printf("%s\n", theLine);
              break;
            }
          }
        } else {
          printf("(1403) %d: Colon is missing XXXXXXXXXXXXXXXXXXXXXXXXXXXXX\n", NR);
        }
        lengthOfTheRest = 0;
        break;
      case 14: # S_leftBraceIsFound
        if (testItCB == "yes") {
          printf("(1409) %d: we are within the new block\n", NR);
          printf("(1410) %d: look for rightBrace[12], break[5], return[] or other statment(s)[12]\n", NR);
        }
        # look for rightBrace[12]
        lfrb = LookForRightBrace(1413);
        if (lfrb == "yes") {
          if (testItCB == "yes") {
            printf("(1416) %d: rightBrace at %d, end of the new block found\n", NR, whereIsRightBrace);
          }
        } else {
          if (testItCB == "yes") {
            printf("(1420) %d: no rightBrace found\n", NR);
          }
          # look for break[5]
          lfb = LookForBreak(1423);
          if (lfb == "yes") {
            if ( testItCB == "yes") {
              printf("(1426) %d: break found[5]\n", NR);
            }
          } else {
            if (testItCB == "yes") {
              printf("(1430) %d: no break found\n", NR);
            }
            # look for return[6]
            if (testItCB == "yes") {
              printf("(1434) %d: no break[11] found\n", NR);
              printf("(1435) %d: look for return[]\n", NR);
            }
            # look for return[6]
            lfr = LookForReturn(1438);
            if (lfr == "yes") {
              if ( testItCB == "yes") {
                printf("(1441) %d: return found[6]\n", NR);
              }
            } else {
              if (testItCB == "yes") {
                printf("(1445) %d: no return found\n", NR);
              }
              if (testItCB == "yes") {
                printf("(1448) %d: look for other statment(s)[12]\n", NR);
              }
              # other statment(s)[12]
              if (testItCB == "yes") {
                printf("(1452) %d: other statment(s)[12] %s\n", NR, theLine);
                printf("(1453) %d: count parenthesis and braces\n", NR);
              }
              CountBraces(theOutLine);
              if (testItCB == "yes") {
                printf("(1457) %d: braceCount= %d\n", NR, braceCount);
              }
              switch (mode) {
              case "check":
                break;
              case "change":
                if (keepTheLine == "yes") {
                  # we have a keeped line
                  if (testItCB == "yes") {
                    printf("(1466) %d: we have a keeped line\n", keepTheNR);
                    printf("(1467) %d>>", keepTheNR);
                  }
                  printf("%s\n", theLineToKeep);
                  keepTheLine = "no";
                  if (testItCB == "yes") {
                    printf("(1472) %d: keepTheLine set to >%s<\n", NR, keepTheLine);
                  }
                }
                if (testItCB == "yes") {
                  printf("(1476) %d>>", NR);
                }
                printf("%s\n", theLine);
                break;
              }
            }
          }
          lengthOfTheRest = 0;
        }
        break;
      case 15: # S_endOfBlockIsFound
        if (testItCB == "yes") {
          printf("(1488) %d*********************: \n", NR);
        }
        break;
      case 116: # S_colonIsFound
        printf("(1492) %d*********************: \n", NR);
        if (testItCB == "yes") {
          printf("(1494) %d: look for a new case[], default[], break[], ", NR);
          printf("return[], leftBrace[], rightBrace[] ");
          printf("or any other statement(s)[]\n");
          printf("(1497) %d: in the theOutLine >%s<\n", NR, theOutLine);
        }
        # look for a new case[]
        lfc = LookForCase(1500);
        if (lfc == "yes") {
          if (testItCB == "yes") {
            printf("(1503) %d: new case found\n", NR);
          }
        } else {
          if (testItCB == "yes") {
            printf("(1507) %d: no new case found\n", NR);
            printf("(1508) %d: look for default[]\n", NR);
          }
          # look for default[]
          lfd = LookForDefault(1511);
          if (lfd == "yes") {
            if (testItCB == "yes") {
              printf("(1514) %d: default found\n", NR);
            }
          } else {
            if (testItCB == "yes") {
              printf("(1518) %d: no default found\n", NR);
              printf("(1519) %d: look for break[]\n", NR);
            }
            # look for break[]
            lfb = LookForBreak(1522);
            if (lfb == "yes") {
              if (braceCount == 1) {
                # break with braceCount is 1, ... without any block
                if (endOfBlockIsFound == "yes") {
                  # we had a new block
                  # break with braceCount is 1, after a new block
                  if (testItCB == "yes") {
                    printf("(1530) %d: break found, after a new block\n", NR);
                  }
                  switch (mode) {
                  case "check":
                    if (testItCB == "yes") {
                      printf("(1535) ");
                    }
                    printf("%d: %s\n", NR, theLine);
                    if (testItCB == "yes") {
                      printf("(1539) ");
                    }
                    printf("%d: break should be placed before the end of the block\n", NR);
                    break;
                  case "change":
                    if (keepTheLine == "yes") {
                      # we have a keeped line
                      if (testItCB == "yes") {
                        printf("(1547) %d: we have a keeped line\n", keepTheNR);
                        printf("(1548) %d>>", keepTheNR);
                      }
                      printf("%s\n", theLineToKeep);
                      keepTheLine = "no";
                      if (testItCB == "yes") {
                        printf("(1553) %d: keepTheLine set to >%s<\n", NR, keepTheLine);
                      }
                    }
                    if (testItCB == "yes") {
                      printf("(1557) %d>>", NR);
                    }
                    # intendation one more  guy
                    printf("    %s\n", theLine);
                    if (testItCB == "yes") {
                      printf("(1562) %d: keepTheLine is >%s<\n", NR, keepTheLine);
                    }
                    if (keepTheLine == "yes") {
                      # we have a keeped line
                      if (testItCB == "yes") {
                        printf("(1567) %d: we have a keeped line\n", keepTheNR);
                        printf("(1568) %d>>", keepTheNR);
                      }
                      printf("%s\n", theLineToKeep);
                      keepTheLine = "no";
                      if (testItCB == "yes") {
                        printf("(1573) %d: keepTheLine set to >%s<\n", NR, keepTheLine);
                      }
                    }
                    break;
                  }
                } else {
                  if (testItCB == "yes") {
                    printf("(1580) %d: break found\n", NR);
                  }
                  switch (mode) {
                  case "check":
                      printf("%d: %s\n", keepTheNR, theLineToKeep);
                      printf("%d: %s\n", NR, theLine);
                      printf("%d: break should be one line upper\n", NR);
                    if (testItCB == "yes") {
                      printf("(1588) %d********>>", NR);
                    }
                    break;
                  case "change":
                    if (keepTheLine == "yes") {
                      # we have a keeped line
                      if (testItCB == "yes") {
                        printf("(1595) %d: we have a keeped line\n", keepTheNR);
                        printf("(1596) %d>>", NR);
                      }
                      printf("    %s\n", theLine);
                      if (testItCB == "yes") {
                        printf("(1600) %d>>", keepTheNR);
                      }
                      printf("%s\n", theLineToKeep);
                      keepTheLine = "no";
                      if (testItCB == "yes") {
                        printf("(1605) %d: keepTheLine set to >%s<\n", NR, keepTheLine);
                      }
                    }
                    break;
                  }
                }
              } else {
                # break with braceCount is > 1, within the new block
                if (testItCB == "yes") {
                  printf("(1614) %d: break found within the new block\n", NR);
                }
                switch (mode) {
                case "check":
                  break;
                case "change":
                  if (keepTheLine == "yes") {
                    # we have a keeped line
                    if (testItCB == "yes") {
                      printf("(1623) %d: we have a keeped line\n", keepTheNR);
                      printf("(1624) %d>>", keepTheNR);
                    }
                    printf("%s\n", theLineToKeep);
                    keepTheLine = "no";
                    if (testItCB == "yes") {
                      printf("(1629) %d: keepTheLine set to >%s<\n", NR, keepTheLine);
                    }
                  }
                  if (testItCB == "yes") {
                    printf("(1633) %d: keepTheLine is >%s<\n", NR, keepTheLine);
                  }
                  if (testItCB == "yes") {
                    printf("(1636) %d>>", NR);
                  }
                  printf("%s\n", theLine);
                  break;
                }
                endOfBlockIsFound = "no";
              }
              S_switchState = S_switchIsFound;
              if (testItCB == "yes") {
                printf("(1645) %d: S_switchState changed to S_switchIsFound\n", NR);
              }
              lengthOfTheRest = 0;
            } else {
              if (testItCB == "yes") {
                printf("(1650) %d: no break found\n", NR);
                printf("(1651) %d: look for return[]\n", NR);
              }
              # look for return[]
              whereIsReturn = index(theOutLine, "return");
              if (testItCB == "yes") {
                printf("(1656) %d: whereIsReturn= %d\n", NR, whereIsReturn);
                printf("(1657) %d: braceCount= %d\n", NR, braceCount);
                printf("(1658) %d: endOfBlockIsFound is >%s<\n", NR, endOfBlockIsFound);
              }
              if (whereIsReturn == 1) {
                if (braceCount == 1) {
                  # return with braceCount is 1, ... without any block
                  if (endOfBlockIsFound == "yes") {
                    # we had a new block
                    # return with braceCount is 1, after a new block
                    if (testItCB == "yes") {
                      printf("(1667) %d: return found, after a new block\n", NR);
                    }
                    switch (mode) {
                    case "check":
                      if (testItCB == "yes") {
                        printf("(1672) ");
                      }
                      printf("%d: %s\n", NR, theLine);
                      if (testItCB == "yes") {
                        printf("(1676) ");
                      }
                      printf("%d: return should be placed before the end of the block\n", NR);
                      break;
                    case "change":
                      if (keepTheLine == "yes") {
                        # we have a keeped line
                        if (testItCB == "yes") {
                          printf("(1684) %d: we have a keeped line\n", keepTheNR);
                          printf("(1685) %d>>", keepTheNR);
                        }
                        printf("%s\n", theLineToKeep);
                        keepTheLine = "no";
                        if (testItCB == "yes") {
                          printf("(1690) %d: keepTheLine set to >%s<\n", NR, keepTheLine);
                        }
                      }
                      if (testItCB == "yes") {
                        printf("(1694) %d>>", NR);
                      }
                      # intendation one more
                      printf("    %s\n", theLine);
                      if (testItCB == "yes") {
                        printf("(1699) %d: keepTheLine is >%s<\n", NR, keepTheLine);
                      }
                      if (keepTheLine == "yes") {
                        # we have a keeped line
                        if (testItCB == "yes") {
                          printf("(1704) %d: we have a keeped line\n", keepTheNR);
                          printf("(1705) %d>>", keepTheNR);
                        }
                        printf("%s\n", theLineToKeep);
                        keepTheLine = "no";
                        if (testItCB == "yes") {
                          printf("(1710) %d: keepTheLine set to >%s<\n", NR, keepTheLine);
                        }
                      }
                      break;
                    }
                 } else {
                    if (testItCB == "yes") {
                      printf("(1717) %d: return found\n", NR);
                    }
                    switch (mode) {
                    case "check":
                      printf("%d: %s\n", keepTheNR, theLineToKeep);
                      printf("%d: %s\n", NR, theLine);
                      printf("%d: return should be one line upper\n", NR);
                      if (testItCB == "yes") {
                        printf("(1725) %d********>>", NR);
                      }
                      break;
                    case "change":
                      if (keepTheLine == "yes") {
                        # we have a keeped line
                        if (testItCB == "yes") {
                          printf("(1732) %d: we have a keeped line\n", keepTheNR);
                          printf("(1733) %d>>", NR);
                        }
                        printf("    %s\n", theLine);
                        if (testItCB == "yes") {
                          printf("(1737) %d>>", keepTheNR);
                        }
                        printf("%s\n", theLineToKeep);
                        keepTheLine = "no";
                        if (testItCB == "yes") {
                          printf("(1742) %d: keepTheLine set to >%s<\n", NR, keepTheLine);
                        }
                      }
                      break;
                    }
                  }
                } else {
                  # return with braceCount is > 1, within the new block
                  if (testItCB == "yes") {
                    printf("(1751) %d: return found within the new block\n", NR);
                  }
                  switch (mode) {
                  case "check":
                    break;
                  case "change":
                    if (keepTheLine == "yes") {
                      # we have a keeped line
                      if (testItCB == "yes") {
                        printf("(1760) %d: we have a keeped line\n", keepTheNR);
                        printf("(1761) %d>>", keepTheNR);
                      }
                      printf("%s\n", theLineToKeep);
                      keepTheLine = "no";
                      if (testItCB == "yes") {
                        printf("(1766) %d: keepTheLine set to >%s<\n", NR, keepTheLine);
                      }
                    }
                    if (testItCB == "yes") {
                      printf("(1770) %d: keepTheLine is >%s<\n", NR, keepTheLine);
                    }
                    if (keepTheLine == "yes") {
                      # we have a keeped line
                      if (testItCB == "yes") {
                        printf("(1775) %d: we have a keeped line\n", keepTheNR);
                        printf("(1776) %d>>", keepTheNR);
                      }
                      printf("%s\n", theLineToKeep);
                      keepTheLine = "no";
                      if (testItCB == "yes") {
                        printf("(1781) %d: keepTheLine set to >%s<\n", NR, keepTheLine);
                      }
                    }
                    if (testItCB == "yes") {
                      printf("(1785) %d>>", NR);
                    }
                    printf("%s\n", theLine);
                    break;
                  }
                  endOfBlockIsFound = "no";
                }
                S_switchState = S_switchIsFound;
                if (testItCB == "yes") {
                  printf("(1794) %d: S_switchState changed to S_switchIsFound\n", NR);
                }
                lengthOfTheRest = 0;
              } else {
                if (testItCB == "yes") {
                  printf("(1799) %d: no return found\n", NR);
                  printf("(1800) %d: look for leftBrace[]\n", NR);
                }
                # look for leftBrace[]
                whereIsLeftBrace = index(theOutLine, leftBrace);
                if (whereIsLeftBrace == 1) {
                  S_switchState = S_leftBraceIsFound;
                  if (testItCB == "yes") {
                    printf("(1807) %d: S_switchState changed to S_leftBraceIsFound\n", NR);
                  }
                  if (testItCB == "yes") {
                    printf("(1810) %d: leftBrace found\n", NR);
                  }
                  lengthOfTheRest = 0;
                  braceCount = braceCount + 1;
                  if (testItCB == "yes") {
                    printf("(1815) %d: braceCount up to %d\n", NR, braceCount);
                    switch (mode) {
                    case "check":
                      break;
                    case "change":
                      printf("(1820) %d: keepTheLine is >%s<\n", NR, keepTheLine);
                      break;
                    }
                  }
                  switch (mode) {
                  case "check":
                    printf("%d: %s\n", keepTheNR, theLineToKeep);
                    printf("%d: %s\n", NR, theLine);
                    printf("%d: the left brace should be one line upper\n", NR);
                    break;
                  case "change":
                    if (keepTheLine == "yes") {
                      # we have a keeped line
                      if (testItCB == "yes") {
                        printf("(1834) %d: we have a keeped line\n", keepTheNR);
                        printf("(1835) %d>>", keepTheNR);
                      }
                      if (oneLineCaseBrace == "yes") {
                        printf("%s\n", theLineToKeep);
                      } else {
                        printf("%s %s\n", theLineToKeep, leftBrace);
                      }
                      keepTheLine = "no";
                      if (testItCB == "yes") {
                        printf("(1844) %d: keepTheLine set to >%s<\n", NR, keepTheLine);
                      }
                    }
                    break;
                  }
                  lengthOfTheRest = 0;
                } else {
                  if (testItCB == "yes") {
                    printf("(1852) %d: no leftBrace found\n", NR);
                    printf("(1853) %d: look for rightBrace[]\n", NR);
                  }
                  # look for rightBrace[]
                  lfrb = LookForRightBrace(1856);
                  if (lfrb == "yes") {
                    if (testItCB == "yes") {
                      printf("(1859) %d: rightBrace found\n", NR);
                    }
                  } else {
                    if (testItCB == "yes") {
                      printf("(1863) %d: no rightBrace found\n", NR);
                      printf("(1864) %d: other statement(s)[] found\n", NR);
                    }
                    # these are statements within the new block
                    CountBraces(theOutLine);
                    if (testItCB == "yes") {
                      printf("(1869) %d: braceCount= %d\n", NR, braceCount);
                    }
                    if (testItCB == "yes") {
                      switch (mode) {
                      case "check":
                        break;
                      case "change":
                        printf("(1876) %d: keepTheLine is >%s<\n", NR, keepTheLine);
                        break;
                      }
                    }
                    switch (mode) {
                    case "check":
                      break;
                    case "change":
                      if (keepTheLine == "yes") {
                        # we have a keeped line
                        if (testItCB == "yes") {
                          printf("(1887) %d: we have a keeped line\n", keepTheNR);
                          printf("(1888) %d>>", keepTheNR);
                        }
                        printf("%s\n", theLineToKeep);
                        keepTheLine = "no";
                        if (testItCB == "yes") {
                          printf("(1893) %d: keepTheLine set to >%s<\n", NR, keepTheLine);
                        }
                      }
                      if (testItCB == "yes") {
                        printf("(1897) %d>>", NR);
                      }
                      printf("%s\n", theLine);
                      break;
                    }
                    keepTheLine = "no";
                    if (testItCB == "yes") {
                      printf("(1904) %d: keepTheLine is >%s<\n", NR, keepTheLine);
                    }
                    lengthOfTheRest = 0;
                  }
                }
              }
            }
          }
        }
        break;
      default:
        printf("(1915) %d: WRONG VALUE for S_switchState= %d\n", NR, S_switchState);
        exit;
      } # switch(S_switchState)
    } # while (lengthOfTheRest > 0)
  } else {
    # this is a comment line
    switch (mode) {
    case "check":
      break;
    case "change":
      if (keepTheLine == "yes") {
        # we have a keeped line
        if (testItCB == "yes") {
          printf("(1928) %d: we have a keeped line\n", keepTheNR);
          printf("(1929) %d>>", keepTheNR);
        }
        printf("%s\n", theLineToKeep);
        keepTheLine = "no";
        if (testItCB == "yes") {
          printf("(1934) %d: keepTheLine set to >%s<\n", NR, keepTheLine);
        }
      }
      if (testItCB == "yes") {
        printf("(1938) %d>>", NR);
      }
      printf("%s\n", theLine);
      break;
    }
  }
}
