BEGIN {
  switch (mode) {
  case "check":
    break;
  case "change":
    break;
  default:
    print "Public.awk: mode is not correct";
    print "it should be \"check\" or \"change\"";
    exit;
  }

  normalLine             = 0;
  comment_1_BeginIsFound = 1;
  comment_1_EndIsFound   = 2;
  comment_2_BeginIsFound = 3;
  string_1_BeginIsFound  = 4;
  string_1_EndIsFound    = 5;
  string_2_BeginIsFound  = 6;
  string_2_EndIsFound    = 7;
  directiveBeginIsFound  = 8;
  directiveEndIsFound    = 9;

  leftBrace  = "{";
  rightBrace = "}";

  switchState = normalLine;

  foundPart_2 = "no";
  numberOfBraces = 0;
  endOfQuestionStatementFound = "no";
  readTheNextLine = "yes";
  colonFound = "no";
  questionFound = "no";
  endOfInitializationFound = "no";
  # variable "doIt" may have one of these values: "no", "prepare" or "yes"
  doIt = "no";
  collectInitialization = "no";
  allTheInitializations = "";
  firstPart = "yes";

  # for debugging, set the following variable(s) to "yes"
  #testIt ="yes";
  #testDefault ="yes";
  #testSplit ="yes";
} # end of BEGIN

function CheckTheNumberOfMember(from)
{
  # check the number of member(s)
  temp = sprintf("called from %d\n", from); 
  Prot((52), temp);
  numberOfParts = SplitComma(withoutColonComma, parts1);
  temp = sprintf("numberOfParts is at %d\n", numberOfParts); 
  Prot((55), temp);
  switch (numberOfParts) {
  case 0:
    printf("(58) *************************** TODO\n");
    exit;
    break;
  case 1:
    # check the last character of the line: it may not be a comma
    lengthOfIt = length(withoutColonComma);
    temp = sprintf("lengthOfIt is at %d\n", lengthOfIt); 
    Prot((65), temp);
    lastCharacter = substr(withoutColonComma, lengthOfIt, 1);
    temp = sprintf("lastCharacter is >%s<\n", lastCharacter); 
    Prot((68), temp);
    if (lastCharacter != ",") {
      Prot((70), "OK\n");
      firstPart = "no";
      temp = sprintf("firstPart set to >%s<\n", firstPart); 
      Prot((73), temp);
      switch (mode) {
      case "check":
        break;
      case "change":
        if (collectInitialization == "no") {
          #temp = sprintf(">>");
          Prot((80), ">>");
          printf("%s\n", theLine);
        }
        break;
      }
    } else {
      switch (mode) {
      case "check":
        Prot((88), "EE\n");
        printf("%d: Comma at the end of an initialization found >%s<\n", NR, theLine);
        printf("%d: should be at the beginning of the next line.\n", NR);
        break;
      case "change":
        allTheInitializations = FirstAwayTrim(withoutColonComma);
        temp = sprintf("allTheInitializations set to >%s<\n", allTheInitializations); 
        Prot((95), temp);
        break;
      }
      collectInitialization = "yes";
      temp = sprintf("collectInitialization set to >%s<\n", collectInitialization); 
      Prot((100), temp);
    }
    break;
  default:
    switch (mode) {
    case "check":
      Prot((106), "EE\n");
      printf("%d: more than one initialization in a line >%s<\n", NR, theLine);
      printf("%d: should be divided in the next line(s).\n", NR);
      break;
    case "change":
      allTheInitializations = FirstAwayTrim(withoutColonComma);
      temp = sprintf("allTheInitializations set to >%s<\n", allTheInitializations); 
      Prot((113), temp);
      break;
    }
    collectInitialization = "yes";
    temp = sprintf("collectInitialization set to >%s<\n", collectInitialization); 
    Prot((118), temp);
    break;
  }
}

function Prot(lineNumber, message)
{
  if (testDefault == "yes") {
    printf("(%d) %d: %s", lineNumber, NR, message);
  }
}

function SplitComma(inLine, inparts,      numberOfCommas, numberOfParts, numberOfBraces, i, character, t1, t2)
{                            # separate local variables from real
                             # parameters  by  extra  spaces
  numberOfCommas = 0;
  numberOfParts = 0;
  numberOfBraces = 0;
  lengthOfTheInLine = length(inLine);
  if (lengthOfTheInLine == 0) {
    return 0;
  }
  if (testSplit == "yes") {
    printf("(141) %d: \n", NR);
    printf("(142) %d: inLine >%s<\n", NR, inLine);
  }
  for (i = 1; i <= lengthOfTheInLine; i++) {
    character = substr(inLine, i, 1);
    switch (character) {
    case "(":
      numberOfBraces += 1;
      temp = sprintf("numberOfBraces is >%d<\n", numberOfBraces);
      Prot((150), temp);
      break;
    case ")":
      numberOfBraces -= 1;
      temp = sprintf("numberOfBraces is >%d<\n", numberOfBraces);
      Prot((155), temp);
      break;
    case ",":
      if (numberOfBraces == 0) {
        # found a comma
        numberOfCommas += 1;
        commaAt[numberOfCommas] = i;
      }
      break;
    default:
      break;
    }
  }
  if (numberOfCommas > 0) {
    if (testSplit == "yes") {
      printf("(170) %d: numberOfCommas= %d\n", NR, numberOfCommas);
    }
    for (i = 1; i <= numberOfCommas; i++) {
      if (testSplit == "yes") {
        printf("(174) %d: commaAt[%d]= %d\n", NR, i, commaAt[i]);
      }
      if (i == 1) {
        # first comma
        if (commaAt[1] == 1) {
          numberOfParts = 0;
            if (commaAt[1] == lengthOfTheInLine) {
              # no more part
            } else {
              # one more part
              numberOfParts += 1;
              t1 = substr(inLine, commaAt[1] + 1);
              inparts[numberOfParts] = FirstAwayTrim(t1);
            }
        } else {
          # first comma NOT at 1
          numberOfParts = 1;
          t1 = substr(inLine, 1, commaAt[1] - 1);
          inparts[1] = FirstAwayTrim(t1);
          if (numberOfCommas == 1) {
            # also last comma
            if (commaAt[1] == lengthOfTheInLine) {
              # no more part
            } else {
              # last part
              numberOfParts += 1;
              t1 = substr(inLine, commaAt[1] + 1);
              inparts[numberOfParts] = FirstAwayTrim(t1);
            }
          }
        }
      } else {
        if (i == numberOfCommas) {
          # last comma
          if (commaAt[numberOfCommas] == lengthOfTheInLine) {
            # no more part
          } else {
            # part before last part
            numberOfParts += 1;
            from = commaAt[i - 1] + 1;
            until = commaAt[i] - 1;
            howMany = until - from + 1;
            t1 = substr(inLine, from, howMany);
            inparts[numberOfParts] = FirstAwayTrim(t1);
            # last part
            numberOfParts += 1;
            t1 = substr(inLine, commaAt[i] + 1);
            inparts[numberOfParts] = FirstAwayTrim(t1);
          }
        } else {
          # one more part, between two commas
          numberOfParts += 1;
          from = commaAt[i - 1] + 1;
          until = commaAt[i] - 1;
          howMany = until - from + 1;
          t1 = substr(inLine, from, howMany);
          inparts[numberOfParts] = FirstAwayTrim(t1);
        }
      }
    }
  } else {
    if (testSplit == "yes") {
      printf("(236) %d: no comma found\n", NR);
    }
    numberOfParts = 1;
    inparts[1] = FirstAwayTrim(inLine);
  }
  if (testSplit == "yes") {
    printf("(242) %d: numberOfParts= %d\n", NR, numberOfParts);
    if (numberOfParts > 0) {
      for (i = 1; i <= numberOfParts; i++) {
        printf("(245) %d: inparts[%d]>%s<\n", NR, i, inparts[i]);
      }
    }
  }
  if (testSplit == "yes") {
    printf("\n");
  }
  return numberOfParts;
}

function FirstNoSpace(inLine,    i, lengthOfTheInLine, character, firstPLace)
{                            # separate local variables from real
                             # parameters  by  extra  spaces
  # looking for first not space character
  lengthOfTheInLine = length(inLine);
  for (i = 1; i <= lengthOfTheInLine; i++) {
    character = substr(inLine, i, 1);
    if (character != " ") {
      firstPLace = i;
      break;
    }
  }
  return firstPLace;
}

function FirstAwayTrim(inLine,    t1, outLine)
{                            # separate local variables from real
                             # parameters  by  extra  spaces
  t1 = FirstSpaceAway(inLine);
  outLine = TrimLine(t1);
  return outLine;
}

function FirstSpaceAway(inLine,    outLine, firstPLace)
{                            # separate local variables from real
                             # parameters  by  extra  spaces
  # looking for first not space character
  firstPLace = FirstNoSpace(inLine);
  outLine = substr(inLine, firstPLace);
  return outLine;
}

function TrimLine(inLine,    lengthOfInLine, letter, tempBuffer)
{                            # separate local variables from real
                             # parameters  by  extra  spaces
  # remove space(s) at end of the line
  lengthOfInLine = length(inLine);
  letter = substr(inLine, lengthOfInLine, 1);
  while (letter == " ") {
    tempBuffer = substr(inLine, 1, lengthOfInLine - 1);
    inLine = tempBuffer;
    lengthOfInLine = length(inLine);
    letter = substr(inLine, lengthOfInLine, 1);
  }
  return inLine;
}

{ # do the job
  theLine = $0;
  if (testIt == "yes") {
    printf("(305) %d:\n", NR);
    printf("(306) %d: theLine >%s<\n", NR, theLine);
    printf("(307) %d: theLine >123456789=123456789=123456789=123456789=123456789=123456789=<\n", NR);
    printf("(308) %d: theLine >         1         2         3         4         5         6<\n", NR);
  }
  restOfTheLine = theLine;
  lengthOfTheRest = length(restOfTheLine);
  workLine = "";

  while (lengthOfTheRest > 0) {
    if (testIt == "yes") {
      printf("(316) %d: switchState= %d\n", NR, switchState);
      switch (switchState) {
      case 0: printf("(318) %d:     normalLine\n", NR); break;
      case 1: printf("(319) %d:     comment_1_BeginIsFound\n", NR); break;
      case 2: printf("(320) %d:     comment_1_EndIsFound\n", NR); break;
      case 3: printf("(321) %d:     comment_2_BeginIsFound\n", NR); break;
      case 4: printf("(322) %d:     string_1_BeginIsFound\n", NR); break;
      case 5: printf("(323) %d:     string_1_EndIsFound\n", NR); break;
      case 6: printf("(324) %d:     string_2_BeginIsFound\n", NR); break;
      case 7: printf("(325) %d:     string_2_EndIsFound\n", NR); break;
      case 8: printf("(326) %d:     directiveBeginIsFound\n", NR); break;
      case 9: printf("(327) %d:     directiveEndIsFound\n", NR); break;
      default:
        printf("(329) %d: WRONG VALUE for switchState= %d\n", NR, switchState);
        exit;
      }
    }
    switch (switchState) {
    case 0: # normalLine
      # first dispatch comment_1/comment_2/string_1/string_2/directive
      whereIsComment_1 = 0;
      whereIsComment_2 = 0;
      whereIsString_1 = 0;
      whereIsString_2 = 0;
      whereIsDirective = 0;
      foundPart_1 = "no";
      lengthOfTheRest = length(restOfTheLine);
      for (i = 1; i <= lengthOfTheRest; i++) {
        character = substr(restOfTheLine, i, 1);
        #if (testIt == "yes") {
        #  printf("(346) %d: look:i= %d, character >%s<\n", NR, i, character);
        #}
        switch (character) {
        case "/":
          if (testIt == "yes") {
            printf("(351) %d: found /\n", NR);
          }
          characterTwo = substr(restOfTheLine, i + 1, 1);
          if (testIt == "yes") {
            printf("(355) %d: characterTwo >%s<\n", NR, characterTwo);
          }
          switch (characterTwo) {
          case "/":
            if (testIt == "yes") {
              printf("(360) %d: found //\n", NR);
            }
            whereIsComment_2 = i;
            foundPart_1 = "yes";
            break;
          case "*":
            if (testIt == "yes") {
              printf("(367) %d: found /*\n", NR);
            }
            whereIsComment_1 = i;
            foundPart_1 = "yes";
            break;
          default:
            break;
          }
          break;
        case "\"":
          if (testIt == "yes") {
            printf("(378) %d: found \"\n", NR);
          }
          whereIsString_1 = i;
          foundPart_1 = "yes";
          break;
        case "'":
          if (testIt == "yes") {
            printf("(385) %d: found '\n", NR);
          }
          whereIsString_2 = i;
          foundPart_1 = "yes";
          break;
        case "#":
          if (testIt == "yes") {
            printf("(392) %d: found '\n", NR);
          }
          whereIsDirective = i;
          foundPart_1 = "yes";
          break;
        default:
          break;
        }
        if (foundPart_1 == "yes") {
           break; 
        }
      }
      if (testIt == "yes") {
        printf("(405) %d: whereIsComment_1= %d\n", NR, whereIsComment_1);
        printf("(406) %d: whereIsComment_2= %d\n", NR, whereIsComment_2);
        printf("(407) %d: whereIsString_1 = %d\n", NR, whereIsString_1);
        printf("(408) %d: whereIsString_2 = %d\n", NR, whereIsString_2);
        printf("(409) %d: whereIsDirective= %d\n", NR, whereIsDirective);
      }
      if (testIt == "yes") {
        printf("(412) %d: dispatch it\n", NR);
      }
      # dispatch it
      if (whereIsComment_1 > 0) {
        if (testIt == "yes") {
          printf("(417) %d: whereIsComment_1= %d\n", NR, whereIsComment_1);
        }
        # [1]
        if (testIt == "yes") {
          printf("(421) %d: switchState changed to comment_1_BeginIsFound\n", NR);
        }
        switchState = comment_1_BeginIsFound;
        partBeforeComment = substr(restOfTheLine, 1, whereIsComment_1 - 1);
        if (testIt == "yes") {
          printf("(426) %d: partBeforeComment >%s<\n", NR, partBeforeComment);
        }
        workLine = workLine partBeforeComment;
        if (testIt == "yes") {
          printf("(430) %d: workLine >%s<\n", NR, workLine);
        }
        temp = substr(restOfTheLine, whereIsComment_1 + 2);
        restOfTheLine = temp;
        lengthOfTheRest = length(restOfTheLine);
        if (testIt == "yes") {
          printf("(436) %d: restOfTheLine >%s<\n", NR, restOfTheLine);
        }
      } else {
        #whereIsComment_2 = index(restOfTheLine, "//");
        if (testIt == "yes") {
          printf("(441) %d: whereIsComment_2= %d\n", NR, whereIsComment_2);
        }
        if (whereIsComment_2 > 0) {
          # []
          if (testIt == "yes") {
            printf("(446) %d: switchState changed to comment_2_BeginIsFound\n", NR);
          }
          switchState = comment_2_BeginIsFound;
          partBeforeComment = substr(restOfTheLine, 1, whereIsComment_2 - 1);
          # remove space(s) at end of the line
          partBefore = TrimLine(partBeforeComment);
          if (testIt == "yes") {
            printf("(453) %d: partBeforeComment >%s<\n", NR, partBeforeComment);
          }
          workLine = workLine partBeforeComment;
          if (testIt == "yes") {
            printf("(457) %d: workLine >%s<\n", NR, workLine);
          }
        } else {
          if (whereIsString_1 > 0) {
            if (testIt == "yes") {
              printf("(462) %d: whereIsString_1= %d\n", NR, whereIsString_1);
            }
            # []
            if (testIt == "yes") {
              printf("(466) %d: switchState changed to string_1_BeginIsFound\n", NR);
            }
            switchState = string_1_BeginIsFound;
            partBeforeString = substr(restOfTheLine, 1, whereIsString_1 - 1);
            if (testIt == "yes") {
              printf("(471) %d: partBeforeString >%s<\n", NR, partBeforeString);
            }
            workLine = workLine partBeforeString;
            if (testIt == "yes") {
              printf("(475) %d: workLine >%s<\n", NR, workLine);
            }
            temp = substr(restOfTheLine, whereIsString_1 + 1);
            restOfTheLine = temp;
            lengthOfTheRest = length(restOfTheLine);
            if (testIt == "yes") {
              printf("(481) %d: restOfTheLine >%s<\n", NR, restOfTheLine);
            }
          } else {
            #whereIsString_2 = index(restOfTheLine, "'");
            if (testIt == "yes") {
              printf("(486) %d: whereIsString_2= %d\n", NR, whereIsString_2);
            }
            if (whereIsString_2 > 0) {
              # []
              if (testIt == "yes") {
                printf("(491) %d: switchState changed to string_2_BeginIsFound\n", NR);
              }
              switchState = string_2_BeginIsFound;
              partBeforeString = substr(restOfTheLine, 1, whereIsString_2 - 1);
              if (testIt == "yes") {
                printf("(496) %d: partBeforeString >%s<\n", NR, partBeforeString);
              }
              workLine = workLine partBeforeString;
              if (testIt == "yes") {
                printf("(500) %d: workLine >%s<\n", NR, workLine);
              }
              temp = substr(restOfTheLine, whereIsString_2 + 1);
              restOfTheLine = temp;
              lengthOfTheRest = length(restOfTheLine);
              if (testIt == "yes") {
                printf("(506) %d: restOfTheLine >%s<\n", NR, restOfTheLine);
              }
            } else {
              #whereIsDirective = index(restOfTheLine, "#define ");
              if (testIt == "yes") {
                printf("(511) %d: whereIsDirective= %d\n", NR, whereIsDirective);
              }
              if (whereIsDirective > 0) {
                # []
                if (testIt == "yes") {
                  printf("(516) %d: switchState changed to directiveBeginIsFound\n", NR);
                }
                switchState = directiveBeginIsFound;
                temp = substr(restOfTheLine, whereIsDirective + 8);
                restOfTheLine = temp;
                lengthOfTheRest = length(restOfTheLine);
                if (testIt == "yes") {
                  printf("(523) %d: restOfTheLine >%s<\n", NR, restOfTheLine);
                }
              } else {
                # it is a normal line
                workLine = workLine restOfTheLine;
                # only for documentation: restOfTheLine = "";
                lengthOfTheRest = 0;
              }
            }
          }
        }
      }
      break;
    case 1: # comment_1_BeginIsFound
      if (testIt == "yes") {
        printf("(538) %d: restOfTheLine >%s<\n", NR, restOfTheLine);
      }
      # looking for */
      whereIsCommentEnd = index(restOfTheLine, "*/");
      if (whereIsCommentEnd > 0) {
        # [2]
        if (testIt == "yes") {
          printf("(545) %d: switchState changed to comment_1_EndIsFound\n", NR);
        }
        switchState = comment_1_EndIsFound;
        # prepare the rest
        temp = substr(restOfTheLine, whereIsCommentEnd + 2);
        restOfTheLine = temp;
        if (testIt == "yes") {
          printf("(552) %d: restOfTheLine >%s<\n", NR, restOfTheLine);
        }
      } else {
        # no comment end found
        lengthOfTheRest = 0;
      }
      if (testIt == "yes") {
        printf("(559) %d: workLine >%s<\n", NR, workLine);
      }
      break;
    case 2: # comment_1_EndIsFound
      if (testIt == "yes") {
        printf("(564) %d: restOfTheLine >%s<\n", NR, restOfTheLine);
      }
      lengthOfTheRest = length(restOfTheLine);
      if (testIt == "yes") {
        printf("(568) %d: switchState changed to normalLine\n", NR);
      }
      switchState = normalLine;
      break;
    case 3: # comment_2_BeginIsFound
      # only for documentation: restOfTheLine = "";
      lengthOfTheRest = 0;
      if (testIt == "yes") {
        printf("(576) %d: switchState changed to normalLine\n", NR);
      }
      switchState = normalLine;
      break;
    case 4: # string_1_BeginIsFound
      if (testIt == "yes") {
        printf("(582) %d: restOfTheLine >%s<\n", NR, restOfTheLine);
        printf("(583) %d: ... looking for \"\n", NR);
      }
      # looking for a closing "
      lengthOfTheRest = length(restOfTheLine);
      i = 1;
      EndIsFound = "no";
      while (i <= lengthOfTheRest && EndIsFound == "no") {
        character = substr(restOfTheLine, i, 1);
        if (testIt == "yes") {
          printf("(592) %d: look:i= %d, character >%s<\n", NR, i, character);
        }
        switch (character) {
        case "\"":
          if (testIt == "yes") {
            printf("(597) %d: found \"\n", NR);
          }
            EndIsFound = "yes";
            whereIsStringEnd = i;
          break;
        case "\\":
          i = i + 1;
          if (testIt == "yes") {
            printf("(605) %d: found \\ escape character at %d\n", NR, i);
          }
          break;
        default:
          break;
        }
        i = i + 1;
      }
      if (testIt == "yes") {
        printf("(614) %d: whereIsStringEnd= %d\n", NR, whereIsStringEnd);
      }
      if (whereIsStringEnd > 0) {
        # []
        if (testIt == "yes") {
          printf("(619) %d: switchState changed to string_1_EndIsFound\n", NR);
        }
        switchState = string_1_EndIsFound;
        # prepare the rest
        temp = substr(restOfTheLine, whereIsStringEnd + 1);
        restOfTheLine = temp;
        if (testIt == "yes") {
          printf("(626) %d: restOfTheLine >%s<\n", NR, restOfTheLine);
        }
      } else {
        # no string end found
        lengthOfTheRest = 0;
      }
      if (testIt == "yes") {
        printf("(633) %d: workLine >%s<\n", NR, workLine);
      }
      break;
    case 5: # string_1_EndIsFound
      if (testIt == "yes") {
        printf("(638) %d: restOfTheLine >%s<\n", NR, restOfTheLine);
      }
      lengthOfTheRest = length(restOfTheLine);
      if (testIt == "yes") {
        printf("(642) %d: switchState changed to normalLine\n", NR);
      }
      switchState = normalLine;
      break;
    case 6: # string_2_BeginIsFound
      if (testIt == "yes") {
        printf("(648) %d: restOfTheLine >%s<\n", NR, restOfTheLine);
      }
      # looking for closing '
      lengthOfTheRest = length(restOfTheLine);
      i = 1;
      EndIsFound = "no";
      while (i <= lengthOfTheRest && EndIsFound == "no") {
        character = substr(restOfTheLine, i, 1);
        if (testIt == "yes") {
          printf("(657) %d: look:i= %d, character >%s<\n", NR, i, character);
        }
        switch (character) {
        case "'":
          if (testIt == "yes") {
            printf("(662) %d: found '\n", NR);
          }
            EndIsFound = "yes";
            whereIsStringEnd = i;
          break;
        case "\\":
          i = i + 1;
          if (testIt == "yes") {
            printf("(670) %d: found \\ escape character at %d\n", NR, i);
          }
          break;
        default:
          break;
        }
        i = i + 1;
      }
      if (testIt == "yes") {
        printf("(679) %d: whereIsStringEnd= %d\n", NR, whereIsStringEnd);
      }
      if (whereIsStringEnd > 0) {
        # []
        if (testIt == "yes") {
          printf("(684) %d: switchState changed to string_2_EndIsFound\n", NR);
        }
        switchState = string_2_EndIsFound;
        # prepare the rest
        temp = substr(restOfTheLine, whereIsStringEnd + 1);
        restOfTheLine = temp;
        if (testIt == "yes") {
          printf("(691) %d: restOfTheLine >%s<\n", NR, restOfTheLine);
        }
      } else {
        # no string end found
        lengthOfTheRest = 0;
      }
      if (testIt == "yes") {
        printf("(698) %d: workLine >%s<\n", NR, workLine);
      }
      break;
    case 7: # string_2_EndIsFound
      if (testIt == "yes") {
        printf("(703) %d: restOfTheLine >%s<\n", NR, restOfTheLine);
      }
      lengthOfTheRest = length(restOfTheLine);
      if (testIt == "yes") {
        printf("(707) %d: switchState changed to normalLine\n", NR);
      }
      switchState = normalLine;
      break;
    case 8: # directiveBeginIsFound
      if (testIt == "yes") {
        printf("(713) %d: restOfTheLine >%s<\n", NR, restOfTheLine);
      }
      # looking for \ at the end of the line
      lengthOfTheRest = length(restOfTheLine);
      letter = substr(restOfTheLine, lengthOfTheRest, 1);
      if (letter != "\\") {
        # []
        if (testIt == "yes") {
          printf("(721) %d: switchState changed to DirectiveEndIsFound\n", NR);
        }
        switchState = directiveEndIsFound;
      } else {
        # the directive goes on on the next line
        lengthOfTheRest = 0;
      }
      break;
    case 9: # directiveEndIsFound
      lengthOfTheRest = 0;
      switchState = normalLine;
      break;
    default:
      printf("(734) %d: WRONG VALUE for switchState= %d\n", NR, switchState);
      exit;
    } # switch (switchState)
  } # while (lengthOfTheRest > 0)
  if (testIt == "yes") {
    printf("(739) %d: (nach while)workLine >%s<\n", NR, workLine);
  }

  # first:
  # empty line(s) [0]

  # second:
  # eliminate all the lines which may have a colon: don't do anything here
  # case          [1]
  # public        [2]
  # protected     [3]
  # private       [4]
  # default       [5]
  # Q_SIGNALS     [6]
  #
  # third
  # the question mark aspect:
  # such a line:
  # latitude *= (mLatDirection->currentIndex() == 1 ? -1 : 1);
  # are difficult to proceed because they might go over more lines.
  #  1. the question mark is before the colon
  #  2. read lines untill the semicolon (end of the statement) is found

  lengthOfTheRest = length(workLine);
  proceedShort = "no";
  Prot((764), "\n");
  temp = sprintf("Input line >%s<\n", theLine);
  Prot((766), temp);
  Prot((767), "           >123456789=123456789=123456789=123456789=123456789=123456789=<\n");
  Prot((768), "           >         1         2         3         4         5         6<\n");
  temp = sprintf("numberOfBraces is >%d<\n", numberOfBraces);
  Prot((770), temp);
  if (lengthOfTheRest == 0) {   # empty line(s)[0]
    # this is an empty line, or the workLine is empty (comment are away)
    proceedShort = "yes";
  }
  # look for case[1]
  whereIsCase = index(workLine, "case ");
  if (whereIsCase > 0) {
    Prot((778), "case found\n");
    proceedShort = "yes";
  }
  # look for public[2]
  whereIsPublic = index(workLine, "public");
  if (whereIsPublic > 0) {
    Prot((784), "public found\n");
    proceedShort = "yes";
  }
  # look for protected[3]
  whereIsChange = index(restOfTheLine, "protected");
  if (whereIsChange > 0) {
    Prot((790), "protected found\n");
    proceedShort = "yes";
  }
  # look for private[4]
  whereIsChange = index(restOfTheLine, "private");
  if (whereIsChange > 0) {
    Prot((796), "default found\n");
    proceedShort = "yes";
  }
  # look for default[5]
  whereIsChange = index(restOfTheLine, "default:");
  if (whereIsChange > 0) {
    Prot((802), "default found\n");
    proceedShort = "yes";
  }
  # look for Q_SIGNALS[6]
  whereIsChange = index(restOfTheLine, "Q_SIGNALS");
  if (whereIsChange > 0) {
    Prot((808), "Q_SIGNALS found\n");
    proceedShort = "yes";
  }

  if (proceedShort == "yes") {
    # don't do anything here
    switch (mode) {
    case "check":
      break;
    case "change":
      #temp =  sprintf(">>");
      Prot((819), ">>");
      printf("%s\n", theLine);
      break;
    }
  } else {
    # the JOB: proceed the line
    temp = sprintf("the JOB: proceed the line\n");
    Prot((826), temp);
    temp = sprintf("readTheNextLine is >%s<\n", readTheNextLine);
    Prot((828), temp);

    # look for : ? ; leftBrace
    restOfTheLine = workLine;
    lengthOfTheRest = length(restOfTheLine);
    where = 1;
    if (readTheNextLine == "yes") {
      temp = sprintf("restOfTheLine is >%s<\n", restOfTheLine);
      Prot((836), temp);
      temp = sprintf("lengthOfTheRest is >%d<\n", lengthOfTheRest);
      Prot((838), temp);
      temp = sprintf("foundPart_2 is >%s<\n", foundPart_2);
      Prot((840), temp);
      while (where <= lengthOfTheRest && (foundPart_2 == "no")) {
        letter = substr(restOfTheLine, where, 1);
        switch (letter) {
        case "(":
          numberOfBraces += 1;
          temp = sprintf("numberOfBraces is >%d<\n", numberOfBraces);
          Prot((847), temp);
          break;
        case ")":
          numberOfBraces -= 1;
          temp = sprintf("numberOfBraces is >%d<\n", numberOfBraces);
          Prot((852), temp);
          break;
        case ":":
          if (numberOfBraces == 0) {
            if (questionFound == "no") {
              # only if we don't found any ?
              letter2 = substr(restOfTheLine, where + 1, 1);
              if (letter2 == ":") {
                # it is ::
                where += 1;
              } else {
                colonFound = "yes";
                position = where;
                temp = sprintf("Colon found at %d\n", position);
                Prot((866), temp);
                doIt = "prepare";
                temp = sprintf("doIt set to >%s<\n", doIt);
                Prot((869), temp);
              }
            }
          } else {
            temp = sprintf("numberOfBraces is >%d<\n", numberOfBraces);
            Prot((874), temp);
          }
          break;
        case "?":
          if (colonFound == "no") {
            # only if we don't found any :
            questionFound = "yes";
            position = where;
            temp = sprintf("Question found at %d\n", position);
            Prot((883), temp);
          }
          break;
        case ";":
          if (questionFound == "yes") {
            # look for the end of the statement
            foundPart_2 = "yes";
            endOfQuestionStatementFound = "yes";
            temp = sprintf("End of the statement found at %d\n", where);
            Prot((892), temp);
          }
          break;
        case "{":
          if (colonFound == "yes") {
            # look for the end of the initialization
            foundPart_2 = "yes";
            endOfInitializationFound = "yes";
            temp = sprintf("End of the initialization found\n");
            Prot((901), temp);
            doIt = "yes";
            temp = sprintf("doIt set to >%s<\n", doIt);
            Prot((904), temp);
          }
          break;
        default:
          break;
        }
        where += 1;
      } # while where <= lengthOfTheRest && (foundPart_2 == "no") ...
      temp = sprintf("at the end of while:\n");
      Prot((913), temp);
      temp = sprintf("colonFound is                  >%s<\n", colonFound);
      Prot((915), temp);
      if (colonFound == "yes") {
        temp = sprintf("... found at %d\n", position);
        Prot((918), temp);
      }
      temp = sprintf("endOfInitializationFound is    >%s<\n", endOfInitializationFound);
      Prot((921), temp);
      temp = sprintf("questionFound is               >%s<\n", questionFound);
      Prot((923), temp);
      if (questionFound == "yes") {
        temp = sprintf("... found at %d\n", position);
        Prot((926), temp);
      }
      temp = sprintf("endOfQuestionStatementFound is >%s<\n", endOfQuestionStatementFound);
      Prot((929), temp);
      if (colonFound == "yes" && endOfInitializationFound == "yes") {
        doIt = "yes";
        readTheNextLine = "no";
        temp = sprintf("readTheNextLine set to >%s<\n", readTheNextLine);
        Prot((934), temp);
      }
      if (questionFound == "yes" && endOfQuestionStatementFound == "yes") {
        readTheNextLine = "no";
        temp = sprintf("readTheNextLine set to >%s<\n", readTheNextLine);
        Prot((939), temp);
      }
    } # if readTheNextLine == "yes" ...
  }
  temp = sprintf("doIt >%s<\n", doIt);
  Prot((944), temp);
  Prot((945), "doIt now\n");
  whereIsFirstNoSpace = FirstNoSpace(theLine);
  temp = sprintf("whereIsFirstNoSpace is at %d\n", whereIsFirstNoSpace);
  Prot((948), temp);
  switch (doIt) {
  case "no":
    temp = sprintf("is another statement\n");
    Prot((952), temp);
    # reset
    readTheNextLine = "yes";
    temp = sprintf("readTheNextLine set to >%s<\n", readTheNextLine);
    Prot((956), temp);
    foundPart_2 = "no";
    questionFound = "no";
    endOfQuestionStatementFound = "no";
    switch (mode) {
    case "check":
      break;
    case "change":
      temp = sprintf("theLine >%s<\n", theLine);
      Prot((965), temp);
      if (proceedShort == "no") {
        #temp = sprintf(">>");
        Prot((968), ">>");
        printf("%s\n", theLine);
      }
      whereIsFirstNoSpace = FirstNoSpace(theLine);
      temp = sprintf("whereIsFirstNoSpace is at %d\n", whereIsFirstNoSpace);
      Prot((973), temp);
      break;
    }
    break;
  case "prepare":
    temp = sprintf("doIt is >%s<\n", doIt);
    Prot((979), temp);
    temp = sprintf("Input line >%s<\n", theLine);
    Prot((981), temp);
    tempLine = FirstAwayTrim(theLine);
    temp = sprintf("tempLine >%s<\n", tempLine);
    Prot((984), temp);
    temp = sprintf("collectInitialization >%s<\n", collectInitialization);
    Prot((986), temp);
    if (collectInitialization == "no") {
      temp = sprintf("firstPart >%s<\n", firstPart);
      Prot((989), temp);
      if (firstPart == "yes") {
        temp = sprintf("Colon is at %d\n", position); 
        Prot((992), temp);
        temp = sprintf("whereIsFirstNoSpace is at %d\n", whereIsFirstNoSpace); 
        Prot((994), temp);
        # check:
        # 1: colon is the first (no white) character of the line
        # 2: colon is not the first
        # 3: it might be a bit-field such as "bool mEmpty : 1;"
        if (whereIsFirstNoSpace == position) {
          # 1: colon is the first (no white) character of the line
          withoutColonComma = substr(tempLine, 3);
          temp = sprintf("withoutColonComma >%s<\n", withoutColonComma);
          Prot((1003), temp);
          # check the number of member(s)
          CheckTheNumberOfMember(1005);
          firstPart = "no";
          temp = sprintf("firstPart set to >%s<\n", firstPart); 
          Prot((1008), temp);
        } else {
          # 2: colon is not the first
          # 3: it might be a bit-field such as "bool mEmpty : 1;"
          # 3: there are NO parenthesis ()
          # 3: there is a semi-colon
          partBeforeColon = substr(theLine, 1, position - 1);
          temp = sprintf("partBeforeColon >%s<\n", partBeforeColon);
          Prot((1016), temp);
          # look for (
          leftParenthesis = index(partBeforeColon, "(");
          temp = sprintf("leftParenthesis =%d\n", leftParenthesis);
          Prot((1020), temp);
          # look for )
          rightParenthesis = index(partBeforeColon, ")");
          temp = sprintf("rightParenthesis =%d\n", rightParenthesis);
          Prot((1024), temp);
          # look for ;
          lengthOfLine = length(theLine);
          temp = sprintf("lengthOfLine =%d\n", lengthOfLine);
          Prot((1028), temp);
          lastCharacter = substr(theLine, lengthOfLine, 1);
          temp = sprintf("lastCharacter >%s<\n", lastCharacter);
          Prot((1031), temp);
          if (leftParenthesis  == 0 &&
              rightParenthesis == 0 &&
              lastCharacter == ";") {
            # 3: it is a bit-field such as "bool mEmpty : 1;"
            Prot((1036), "it is a bit-field\n");
            # don't do anything here
            switch (mode) {
            case "check":
              break;
            case "change":
              #temp =  sprintf(">>");
              Prot((1043), ">>");
              printf("%s\n", theLine);
              break;
            }
            # reset
            doIt = "no";
            temp = sprintf("doIt set to >%s<\n", doIt);
            Prot((1050), temp);
            readTheNextLine = "yes";
            temp = sprintf("readTheNextLine set to >%s<\n", readTheNextLine);
            Prot((1053), temp);
            foundPart_2 = "no";
            colonFound = "no";
            endOfInitializationFound = "no";
            firstPart = "yes";
            temp = sprintf("firstPart set to >%s<\n", firstPart); 
            Prot((1059), temp);
          } else {
            switch (mode) {
            case "check":
              Prot((1063), "EE\n");
              printf("%d: initialization colon found at %d >%s<\n", NR, position, theLine);
              printf("%d: should be at the beginning of the next line.\n", NR);
              break;
            case "change":
              temp = substr(theLine, 1, position - 1);
              partBeforeColon = TrimLine(temp);
              lengthBeforeColon = length(partBeforeColon);
              if (lengthBeforeColon > 0) {
                temp = sprintf("partBeforeColon set to >%s<\n", partBeforeColon); 
                Prot((1073), temp);
                #temp = sprintf(">>");
                Prot((1075), ">>");
                printf("%s\n", partBeforeColon);
                Prot((1077), "Test Dateien 4 und 5\n");
                whereIsFirstNoSpace = FirstNoSpace(theLine);
                temp = sprintf("whereIsFirstNoSpace is at %d\n", whereIsFirstNoSpace);
                Prot((1080), temp);
              }
              allTheInitializations = substr(theLine, position + 1);
              temp = sprintf("allTheInitializations set to >%s<\n", allTheInitializations); 
              Prot((1084), temp);
              break;
            }
            collectInitialization = "yes";
            temp = sprintf("collectInitialization set to >%s<\n", collectInitialization); 
            Prot((1089), temp);
          }
        }
      } else {
        # second (or next) part
        # check the first character of the line: it must be a comma
        firstCharacter = substr(tempLine, 1, 1);
        temp = sprintf("firstCharacter is >%s<\n", firstCharacter); 
        Prot((1097), temp);
        if (firstCharacter == ",") {
          Prot((1099), "OK\n");
          withoutColonComma = substr(tempLine, 3);
          temp = sprintf("withoutColonComma >%s<\n", withoutColonComma);
          # check the number of member(s)
          CheckTheNumberOfMember(1103);
        } else {
          switch (mode) {
          case "check":
            Prot((1107), "EE\n");
            printf("%d: missing colon/comma at the beginning of the line >%s<\n", NR, theLine);
            break;
          case "change":
            break;
          }
        }
      }
    } else {
      # we don't take care of "firstPart" 
      switch (mode) {
      case "check":
        break;
      case "change":
        Prot((1121), "collect all the initialization(s) until leftBrace\n");
        allTheInitializations = allTheInitializations " " tempLine;
        temp = sprintf("allTheInitializations set to >%s<\n", allTheInitializations); 
        Prot((1124), temp);
        break;
      }
    }
    # don't do anything more, read the next line
    break;
  case "yes":
    temp = sprintf("doooooooooooooo it the JOB\n");
    Prot((1132), temp);
    # reset
    readTheNextLine = "yes";
    temp = sprintf("readTheNextLine set to >%s<\n", readTheNextLine);
    Prot((1136), temp);
    foundPart_2 = "no";
    colonFound = "no";
    endOfInitializationFound = "no";
    firstPart = "yes";
    temp = sprintf("firstPart set to >%s<\n", firstPart); 
    Prot((1142), temp);
    switch (mode) {
    case "check":
      break;
    case "change":
      if (collectInitialization == "yes") {
        temp = sprintf("allTheInitializations is >%s<\n", allTheInitializations); 
        Prot((1149), temp);
        numberOfParts = SplitComma(allTheInitializations, parts1);
        temp = sprintf("numberOfParts is at %d\n", numberOfParts); 
        Prot((1152), temp);
        if (numberOfParts > 0) {
          temp = sprintf("whereIsFirstNoSpace is at %d\n", whereIsFirstNoSpace); 
          Prot((1155), temp);
          for (i = 1; i <= numberOfParts; i++) {
            temp = sprintf("parts1[%d]>%s<\n", i, parts1[i]);
            Prot((1158), temp);
            #temp = sprintf(">>");
            Prot((1160), ">>");
            for (j = 1; j < whereIsFirstNoSpace + 4; j++) {
              printf(" ");
            }
            if (i == 1) {
              printf(": ");
            } else {
              printf(", ");
            }
            printf("%s\n", parts1[i]);
          }
          # reset
          collectInitialization = "no";
          temp = sprintf("collectInitialization set to >%s<\n", collectInitialization); 
          Prot((1174), temp);
        } else {
          printf("(1176) *************************** TODO\n");
          exit;    
        }
      }
      #temp = sprintf(">>");
      Prot((1181), ">>");
      printf("%s\n", theLine);
      break;
    }
    doIt = "no";
    break;
  }
}
