BEGIN {
  if (mode != "check") {
    if (mode != "change") {
      print ".awk: mode is not correct";
      print "it should be \"check\" or \"change\"";
      exit;
    }
  }

  normalLine             = 0;
  comment_1_BeginIsFound = 1;
  comment_1_EndIsFound   = 2;
  comment_2_BeginIsFound = 3;
  string_1_BeginIsFound  = 4;
  string_1_EndIsFound    = 5;
  string_2_BeginIsFound  = 6;
  string_2_EndIsFound    = 7;
  directiveBeginIsFound  = 8;
  directiveEndIsFound    = 9;

  leftBrace  = "{";
  rightBrace = "}";

  switchState = normalLine;

  enumBraceMissing = "no";
  theLineBefore = "";
  inEnum = "no";

  # for debugging, set the following variable(s) to "yes"
  #testIt ="yes";
  #testEnum ="yes";
} # end of BEGIN

function Prot(lineNumber, message)
{
  if (testEnum == "yes") {
    printf("(%d) %d: %s", lineNumber, NR, message);
  }
}

function FirstNoSpace(inLine,    i, lengthOfTheInLine, character, firstPLace)
{                              # separate local variables from real parameters by extra spaces
  # looking for first not space character
  lengthOfTheInLine = length(inLine);
  for (i = 1; i <= lengthOfTheInLine; i++) {
    character = substr(inLine, i, 1);
    if (character != " ") {
      firstPLace = i;
      break;
    }
  }
  return firstPLace;
}

function FirstSpaceAway(inLine,    outLine, firstPLace)
{                              # separate local variables from real parameters by extra spaces
  # looking for first not space character
  firstPLace = FirstNoSpace(inLine);
  outLine = substr(inLine, firstPLace);
  return outLine;
}

function PutIndentation(lengthOfIndentation,          i)
{                                # separate local variables from real parameters by extra spaces
  indentation = "";
  for (i = 1; i<= lengthOfIndentation; i++) {
    indentation = sprintf("%s ", indentation);
  }
}

function TrimLine(inLine,    lengthOfInLine, letter, tempBuffer)
{                              # separate local variables from real parameters by extra spaces
  # remove space(s) at end of the line
  lengthOfInLine = length(inLine);
  letter = substr(inLine, lengthOfInLine, 1);
  while (letter == " ") {
    tempBuffer = substr(inLine, 1, lengthOfInLine - 1);
    inLine = tempBuffer;
    lengthOfInLine = length(inLine);
    letter = substr(inLine, lengthOfInLine, 1);
  }
  return inLine;
}

{ # do the job
  theLine = $0;
  if (testIt == "yes") {
    printf("\n%d, ====>:%s:\n", NR, theLine);
  }
  restOfTheLine = theLine;
  lengthOfTheRest = length(restOfTheLine);
  workLine = "";

  while (lengthOfTheRest > 0) {
    if (testIt == "yes") {
      printf("switchState(97)(%d)=%d\n", NR, switchState);
      switch (switchState) {
      case 0: printf("    normalLine\n"); break;
      case 1: printf("    comment_1_BeginIsFound\n"); break;
      case 2: printf("    comment_1_EndIsFound\n"); break;
      case 3: printf("    comment_2_BeginIsFound\n"); break;
      case 4: printf("    string_1_BeginIsFound\n"); break;
      case 5: printf("    string_1_EndIsFound\n"); break;
      case 6: printf("    string_2_BeginIsFound\n"); break;
      case 7: printf("    string_2_EndIsFound\n"); break;
      case 8: printf("    directiveBeginIsFound\n"); break;
      case 9: printf("    directiveEndIsFound\n"); break;
      }
    }
    switch(switchState) {
    case 0: # normalLine
      # first dispatch comment_1/comment_2/string_1/string_2/directive
      whereIsComment_1 = index(restOfTheLine, "/*");
      whereIsComment_2 = index(restOfTheLine, "//");
      whereIsString_1 = index(restOfTheLine, "\"");
      whereIsString_2 = index(restOfTheLine, "'");
      if (testIt == "yes") {
        printf("whereIsComment_1= %d\n", whereIsComment_1);
        printf("whereIsComment_2= %d\n", whereIsComment_2);
        printf("whereIsString_1= %d\n", whereIsString_1);
        printf("whereIsString_2= %d\n", whereIsString_2);
      }
      # dispatch it
      if (whereIsComment_1 > 0) {
        # [1]
        if (testIt == "yes") {
          printf("switchState(128)(%d) changed to comment_1_BeginIsFound\n", NR);
        }
        switchState = comment_1_BeginIsFound;
        partBeforeComment = substr(restOfTheLine, 1, whereIsComment_1 - 1);
        if (testIt == "yes") {
          printf("(133)partBeforeComment >>%s<<\n", partBeforeComment);
        }
        workLine = workLine partBeforeComment;
        if (testIt == "yes") {
          printf("(137)workLine >>%s<<:\n", workLine);
        }
        temp = substr(restOfTheLine, whereIsComment_1 + 2);
        restOfTheLine = temp;
        lengthOfTheRest = length(restOfTheLine);
        if (testIt == "yes") {
          printf("%d:(143)restOfTheLine >>%s<<\n", NR, restOfTheLine);
        }
      } else {
        whereIsComment_2 = index(restOfTheLine, "//");
        if (testIt == "yes") {
          printf("whereIsComment_2= %d\n", whereIsComment_2);
        }
        if (whereIsComment_2 > 0) {
          # []
          if (testIt == "yes") {
            printf("switchState(153)(%d) changed to comment_2_BeginIsFound\n", NR);
          }
          switchState = comment_2_BeginIsFound;
          partBeforeComment = substr(restOfTheLine, 1, whereIsComment_2 - 1);
          # remove space(s) at end of the line
          partBefore = TrimLine(partBeforeComment);
          if (testIt == "yes") {
            printf("(160)partBeforeComment >>%s<<\n", partBeforeComment);
          }
          workLine = workLine partBeforeComment;
          if (testIt == "yes") {
            printf("(164)workLine >>%s<<:\n", workLine);
          }
        } else {
          whereIsString_1 = index(restOfTheLine, "\"");
          if (testIt == "yes") {
            printf("whereIsString_1= %d\n", whereIsString_1);
          }
          whereIsString_2 = index(restOfTheLine, "'");
          if (testIt == "yes") {
            printf("whereIsString_2= %d\n", whereIsString_2);
          }
          if ((whereIsString_1 > 0) && (whereIsString_2 > 0)) {
            if (testIt == "yes") {
              printf("choosing ...\n");
            }
            # check which one is first
            if (whereIsString_1 < whereIsString_2) {
              # whereIsString_1 is first
              whereIsString_2 = 0;
            } else {
              # whereIsString_2 is first
              whereIsString_1 = 0;
            }
          } else {
            # nothing to check
          }
          if (testIt == "yes") {
            printf("after choosing: whereIsString_1= %d\n", whereIsString_1);
          }
          if (testIt == "yes") {
            printf("after choosing: whereIsString_2= %d\n", whereIsString_2);
          }
          if (whereIsString_1 > 0) {
            # []
            if (testIt == "yes") {
              printf("switchState(199)(%d) changed to string_1_BeginIsFound\n", NR);
            }
            switchState = string_1_BeginIsFound;
            partBeforeString = substr(restOfTheLine, 1, whereIsString_1 - 1);
            if (testIt == "yes") {
              printf("(204)partBeforeString >>%s<<\n", partBeforeString);
            }
            workLine = workLine partBeforeString;
            if (testIt == "yes") {
              printf("(208)workLine >>%s<<:\n", workLine);
            }
            temp = substr(restOfTheLine, whereIsString_1 + 1);
            restOfTheLine = temp;
            lengthOfTheRest = length(restOfTheLine);
            if (testIt == "yes") {
              printf("%d:(214)restOfTheLine >>%s<<\n", NR, restOfTheLine);
            }
          } else {
            whereIsString_2 = index(restOfTheLine, "'");
            if (testIt == "yes") {
              printf("whereIsString_2= %d\n", whereIsString_2);
            }
            if (whereIsString_2 > 0) {
              # []
              if (testIt == "yes") {
                printf("switchState(224)(%d) changed to string_2_BeginIsFound\n", NR);
              }
              switchState = string_2_BeginIsFound;
              partBeforeString = substr(restOfTheLine, 1, whereIsString_2 - 1);
              if (testIt == "yes") {
                printf("(229)partBeforeString >>%s<<\n", partBeforeString);
              }
              workLine = workLine partBeforeString;
              if (testIt == "yes") {
                printf("(233)workLine >>%s<<:\n", workLine);
              }
              temp = substr(restOfTheLine, whereIsString_2 + 1);
              restOfTheLine = temp;
              lengthOfTheRest = length(restOfTheLine);
              if (testIt == "yes") {
                printf("%d:(239)restOfTheLine >>%s<<\n", NR, restOfTheLine);
              }
            } else {
              whereIsDirective = index(restOfTheLine, "#define ");
              if (testIt == "yes") {
                printf("whereIsDirective= %d\n", whereIsDirective);
              }
              if (whereIsDirective > 0) {
                # []
                if (testIt == "yes") {
                  printf("switchState(249)(%d) changed to directiveBeginIsFound\n", NR);
                }
                switchState = directiveBeginIsFound;
                temp = substr(restOfTheLine, whereIsDirective + 8);
                restOfTheLine = temp;
                lengthOfTheRest = length(restOfTheLine);
                if (testIt == "yes") {
                  printf("%d:(256)restOfTheLine >>%s<<\n", NR, restOfTheLine);
                }
              } else {
                # it is a normal line
                workLine = workLine restOfTheLine;
                if (testIt == "yes") {
                  printf("(262)workLine >>%s<<:\n", workLine);
                }
                # only for documentation: restOfTheLine = "";
                lengthOfTheRest = 0;
              }
            }
          }
        }
      }
      break;
    case 1: # comment_1_BeginIsFound
      if (testIt == "yes") {
        printf("%d:(274)restOfTheLine >>%s<<\n", NR, restOfTheLine);
      }
      # looking for */
      whereIsCommentEnd = index(restOfTheLine, "*/");
      if (whereIsCommentEnd > 0) {
        # [2]
        if (testIt == "yes") {
          printf("switchState(281)(%d) changed to comment_1_EndIsFound\n", NR);
        }
        switchState = comment_1_EndIsFound;
        # prepare the rest
        temp = substr(restOfTheLine, whereIsCommentEnd + 2);
        restOfTheLine = temp;
        if (testIt == "yes") {
          printf("(288)restOfTheLine >>%s<<\n", restOfTheLine);
        }
      } else {
        # no comment end found
        lengthOfTheRest = 0;
      }
      if (testIt == "yes") {
        printf("(295)workLine >>%s<<:\n", workLine);
      }
      break;
    case 2: # comment_1_EndIsFound
      if (testIt == "yes") {
        printf("(300)restOfTheLine >>%s<<\n", restOfTheLine);
      }
      lengthOfTheRest = length(restOfTheLine);
      if (testIt == "yes") {
        printf("switchState(304)(%d) changed to normalLine\n", NR);
      }
      switchState = normalLine;
      break;
    case 3: # comment_2_BeginIsFound
      # only for documentation: restOfTheLine = "";
      lengthOfTheRest = 0;
      if (testIt == "yes") {
        printf("switchState(312)(%d) changed to normalLine\n", NR);
      }
      switchState = normalLine;
      break;
    case 4: # string_1_BeginIsFound
      if (testIt == "yes") {
        printf("%d:(318)restOfTheLine >>%s<<\n", NR, restOfTheLine);
        printf("... looking for \"\n");
      }
      # looking for a closing "
      lengthOfTheRest = length(restOfTheLine);
      i = 1;
      EndIsFound = "no";
      while (i <= lengthOfTheRest && EndIsFound == "no") {
        character = substr(restOfTheLine, i, 1);
        if (testIt == "yes") {
          printf("look:i=%d, character=:%s:\n", i, character);
        }
        switch (character) {
        case "\"":
          if (testIt == "yes") {
            printf("found \"\n");
          }
            EndIsFound = "yes";
            whereIsStringEnd = i;
          break;
        case "\\":
          i = i + 1;
          if (testIt == "yes") {
            printf("found \\ escape character %d\n", i);
          }
          break;
        default:
          break;
        }
        i = i + 1;
      }
      if (testIt == "yes") {
        printf("%d:(350)whereIsStringEnd=%d\n", NR, whereIsStringEnd);
      }
      if (whereIsStringEnd > 0) {
        # []
        if (testIt == "yes") {
          printf("switchState(355)(%d) changed to string_1_EndIsFound\n", NR);
        }
        switchState = string_1_EndIsFound;
        # prepare the rest
        temp = substr(restOfTheLine, whereIsStringEnd + 1);
        restOfTheLine = temp;
        if (testIt == "yes") {
          printf("(362)restOfTheLine >>%s<<\n", restOfTheLine);
        }
      } else {
        # no string end found
        lengthOfTheRest = 0;
      }
      if (testIt == "yes") {
        printf("(369)workLine >>%s<<:\n", workLine);
      }
      break;
    case 5: # string_1_EndIsFound
      if (testIt == "yes") {
        printf("(374)restOfTheLine >>%s<<\n", restOfTheLine);
      }
      lengthOfTheRest = length(restOfTheLine);
      if (testIt == "yes") {
        printf("switchState(378)(%d) changed to normalLine\n", NR);
      }
      switchState = normalLine;
      break;
    case 6: # string_2_BeginIsFound
      if (testIt == "yes") {
        printf("%d:(384)restOfTheLine >>%s<<\n", NR, restOfTheLine);
      }
      # looking for closing '
      lengthOfTheRest = length(restOfTheLine);
      i = 1;
      EndIsFound = "no";
      while (i <= lengthOfTheRest && EndIsFound == "no") {
        character = substr(restOfTheLine, i, 1);
        if (testIt == "yes") {
          printf("look:i=%d, character=:%s:\n", i, character);
        }
        switch (character) {
        case "'":
          if (testIt == "yes") {
            printf("found '\n");
          }
            EndIsFound = "yes";
            whereIsStringEnd = i;
          break;
        case "\\":
          i = i + 1;
          if (testIt == "yes") {
            printf("found \\ escape character %d\n", i);
          }
          break;
        default:
          break;
        }
        i = i + 1;
      }
      if (testIt == "yes") {
        printf("%d:(415)whereIsStringEnd=%d\n", NR, whereIsStringEnd);
      }
      if (whereIsStringEnd > 0) {
        # []
        if (testIt == "yes") {
          printf("switchState(420)(%d) changed to string_2_EndIsFound\n", NR);
        }
        switchState = string_2_EndIsFound;
        # prepare the rest
        temp = substr(restOfTheLine, whereIsStringEnd + 1);
        restOfTheLine = temp;
        if (testIt == "yes") {
          printf("(427)restOfTheLine >>%s<<\n", restOfTheLine);
        }
      } else {
        # no string end found
        lengthOfTheRest = 0;
      }
      if (testIt == "yes") {
        printf("(434)workLine >>%s<<:\n", workLine);
      }
      break;
    case 7: # string_2_EndIsFound
      if (testIt == "yes") {
        printf("(439)restOfTheLine >>%s<<\n", restOfTheLine);
      }
      lengthOfTheRest = length(restOfTheLine);
      if (testIt == "yes") {
        printf("switchState(443)(%d) changed to normalLine\n", NR);
      }
      switchState = normalLine;
      break;
    case 8: # directiveBeginIsFound
      if (testIt == "yes") {
        printf("%d:(449)restOfTheLine >>%s<<\n", NR, restOfTheLine);
      }
      # looking for \ at the end of the line
      lengthOfTheRest = length(restOfTheLine);
      letter = substr(restOfTheLine, lengthOfTheRest, 1);
      if (letter != "\\") {
        # []
        if (testIt == "yes") {
          printf("switchState(457)(%d) changed to DirectiveEndIsFound\n", NR);
        }
        switchState = directiveEndIsFound;
      } else {
        # the directive goes on on the next line
        lengthOfTheRest = 0;
      }
      break;
    case 9: # directiveEndIsFound
      lengthOfTheRest = 0;
      switchState = normalLine;
      break;
    default:
      printf("(470) %d: WRONG VALUE for switchState=%d\n", NR, switchState);
      exit;
    } # switch(switchState)
  } # while (lengthOfTheRest > 0)
  if (testIt == "yes") {
    printf("(nach while)workLine >>%s<<\n", workLine);
  }

  Prot((478), "\n");
  temp = sprintf("workLine >%s<\n", workLine);
  Prot((480), temp);
  # look for enum
  if (enumBraceMissing == "no") {
    #whereIsEnum = index(workLine, " enum ");
    whereIsEnum = index(workLine, "enum ");
    if (whereIsEnum > 0) {
      temp = sprintf("whereIsEnum=%d\n", whereIsEnum);
      Prot((487), temp);
      lengthOfTheLine = length(workLine);
      letter = substr(workLine, lengthOfTheLine, 1);
      # look for leftBrace at the end of the line
      if (letter != leftBrace) {
        temp = sprintf("letter at the end of the line >%c<\n", letter);
        Prot((493), temp);
        if (letter == ";") {
          # enum Result { Undefined, OK, Canceled, Failed };
          if (mode == "check") {
            temp = sprintf("(497) %d:", NR);
            Prot((498), temp);
            printf("%d: Enum should be over more lines: %s\n", NR, theLine);
          }
        } else {
          temp = sprintf("EnumBrace missing:%s\n", theLine);
          Prot((503), temp);
          if (mode == "check") {
            temp = sprintf("(505) %d:", NR);
            Prot((506), temp);
            printf("%d: EnumBrace missing:%s\n", NR, theLine);
          }
          # have a look to the next line ...
          enumBraceMissing = "yes";
          theLineBefore = workLine;
        }
        if (enumBraceMissing == "no") {
          # it must be "no"
          if (mode == "change") {
            # build the indentation
            PutIndentation(whereIsEnum);
            theOutLine = FirstSpaceAway(workLine);
            whereIsBrace = index(theOutLine, leftBrace);
            firstPart = substr(theOutLine, 1, whereIsBrace);
            temp = sprintf(">>");
            Prot((522), temp);
            printf("%s%s\n", indentation, firstPart);
            secondPart = substr(theOutLine, whereIsBrace + 1);
            temp = sprintf("secondPart >%s<\n", secondPart);
            Prot((526), temp);
            theOutLine = FirstSpaceAway(secondPart);
            temp = sprintf("theOutLine >%s<\n", theOutLine);
            Prot((529), temp);
            temp = sprintf("look for rightBrace\n");
            Prot((531), temp);
            whereIsRightBrace = index(theOutLine, rightBrace);
            if (whereIsRightBrace > 0) {
              temp = sprintf("rightBrace found\n");
              Prot((535), temp);
            }
            temp = substr(theOutLine, 1, whereIsRightBrace - 1);
            # remove space(s) at end of the line
            thePartInTheMiddle = TrimLine(temp);
            temp = sprintf("thePartInTheMiddle>%s<\n", thePartInTheMiddle);
            Prot((541), temp);
            temp = substr(theOutLine, whereIsRightBrace + 1);
            # remove space(s) at end of the line
            lastPartOfTheLine = TrimLine(temp);
            temp = sprintf("lastPartOfTheLine>%s<\n", lastPartOfTheLine);
            Prot((546), temp);
            # split the secondPart
            numberOfParts = split(thePartInTheMiddle, theParts, ",");
            for (i = 1; i <= numberOfParts; i++) {
              temp = FirstSpaceAway(theParts[i]);
              theParts[i] = temp;
            }
            if (testEnum == "yes") {
              temp = sprintf("numberOfParts=%d\n", numberOfParts);
              Prot((555), temp);
              for (i = 1; i <= numberOfParts; i++) {
                temp = sprintf("part[%d]=%s\n", i, theParts[i]);
                Prot((558), temp);
              }
            }
            # the parts, not the last one
            for (i = 1; i < numberOfParts; i++) {
              Prot((563), ">>");
              printf("%s    %s,\n", indentation, theParts[i]);
            }
            # the last part
            Prot((567), ">>");
            printf("%s    %s\n", indentation, theParts[numberOfParts]);
            Prot((569), ">>");
            printf("%s%s\n", indentation, rightBrace);
            Prot((571), ">>");
            printf("%s%s\n", indentation, lastPartOfTheLine);
          }
        }
      } else {
        # a leftBrace at the end of the line found
        letterBefore = substr(workLine, lengthOfTheLine - 1, 1);
        # look for a space before
        if (letterBefore != " ") {
          if (mode == "check") {
            printf("%d: a space is missing before brace: %s\n", NR, theLine);
          }
          if (mode == "change") {
            sub("{", " {", theLine);
            Prot((585), ">>");
            printf("%s\n", theLine);
          }
        } else {
          # check the enumType, should begin with a capital letter
          enumType = substr(workLine, whereIsEnum + 5, lengthOfTheLine - 11);
          temp = sprintf("enumType >%s\n", enumType);
          Prot((592), temp);
          firstLetter = substr(enumType, 1, 1);
          temp = sprintf("firstLetter >%c<\n", firstLetter);
          Prot((595), temp);
          if (firstLetter >= "A" &&
              firstLetter <= "Z"   ) {
            # OK
          } else {
            if (mode == "check") {
              printf("%d: enumType >%s< should begin with a capital letter: %s\n", NR, enumType, theLine);
            }
          }
          if (mode == "change") {
            Prot((605), ">>");
            printf("%s\n", theLine);
          }
        }
      }
    } else {
      if (mode == "change") {
        Prot((612), ">>");
        printf("%s\n", theLine);
      }
    }
  } else {
    # enumBraceMissing is "yes"
    # looking at the next line for a leftBrace
    theOutLine = FirstSpaceAway(workLine);
    letter = substr(theOutLine, 1, 1);
    if (letter == leftBrace) {
      # leftBrace found at the next line
      if (mode == "check") {
        temp = sprintf("leftBrace found at the next line\n");
        Prot((625), temp);
      }
      if (mode == "change") {
        # change the two lines into one
        Prot((629), ">>");
        printf("%s {\n", theLineBefore);
      }
      enumBraceMissing = "no"
    } else {
        # as the source was already compiled, the line is "leftBrace"
    }
  }

  if (mode == "check") {
    # look for "enum {"
    whereIsEnum = index(workLine, " enum {");
    if (whereIsEnum > 0) {
      printf("%d: untyped Enum found: %s\n", NR, theLine);
    }
  }

  if (inEnum == "no") {
    # look for enum
    whereIsEnum = index(workLine, " enum ");
    if (whereIsEnum > 0) {
      inEnum = "yes";
      numberOfLine = NR;
    } else {
      # look for Comma at the end of a line
      whereIsComma = index(worktheLine, ",");
      if (whereIsComma > 0) {
        lengthOfTheLine = length(workLine);
        if( whereIsComma == lengthOfTheLine ) {
          if (mode == "check") {
            printf("%d: Comma at the end of the line(%d): %s\n", NR, whereIsComma, theLine);
          }
        }
      }
    }
  } else {
    # look for }
    whereIsEnumEnd = index(workLine, " }");
    if (whereIsEnumEnd > 0) {
      inEnum = "no";
    }
  }
}
