BEGIN {
  switch (mode) {
  case "check":
    break;
  case "change":
    break;
  default:
    print "Public.awk: mode is not correct";
    print "it should be \"check\" or \"change\"";
    exit;
  }

  normalLine             = 0;
  comment_1_BeginIsFound = 1;
  comment_1_EndIsFound   = 2;
  comment_2_BeginIsFound = 3;
  string_1_BeginIsFound  = 4;
  string_1_EndIsFound    = 5;
  string_2_BeginIsFound  = 6;
  string_2_EndIsFound    = 7;
  directiveBeginIsFound  = 8;
  directiveEndIsFound    = 9;

  leftBrace  = "{";
  rightBrace = "}";

  switchState = normalLine;

  namespaceWithBrace = "yes";
  lineBefore = "";

  #testIt ="no";
  #testIt ="yes";
  #testNS ="no";
  #testNS ="yes";
} # end of BEGIN

function TrimLine(inLine,    lengthOfInLine, letter, tempBuffer)
{                              # separate local variables from real  parameters  by  extra  spaces
  # remove space(s) at end of the line
  lengthOfInLine = length(inLine);
  letter = substr(inLine, lengthOfInLine, 1);
  while (letter == " ") {
    tempBuffer = substr(inLine, 1, lengthOfInLine - 1);
    inLine = tempBuffer;
    lengthOfInLine = length(inLine);
    letter = substr(inLine, lengthOfInLine, 1);
  }
  return inLine;
}

{ # do the job
  theLine = $0;
  if (testIt == "yes") {
    printf("\n%d, Input Line >%s<\n", NR, theLine);
  }
  if (testNS == "yes") {
    printf("\n%d, Input Line >%s<\n", NR, theLine);
  }
  restOfTheLine = theLine;
  lengthOfTheRest = length(restOfTheLine);
  workLine = "";

  while (lengthOfTheRest > 0) {
    if (testIt == "yes") {
      printf("switchState(66)(%d)= %d\n", NR, switchState);
      switch (switchState) {
      case 0: printf("    normalLine\n"); break;
      case 1: printf("    comment_1_BeginIsFound\n"); break;
      case 2: printf("    comment_1_EndIsFound\n"); break;
      case 3: printf("    comment_2_BeginIsFound\n"); break;
      case 4: printf("    string_1_BeginIsFound\n"); break;
      case 5: printf("    string_1_EndIsFound\n"); break;
      case 6: printf("    string_2_BeginIsFound\n"); break;
      case 7: printf("    string_2_EndIsFound\n"); break;
      case 8: printf("    directiveBeginIsFound\n"); break;
      case 9: printf("    directiveEndIsFound\n"); break;
      }
    }
    switch(switchState) {
    case 0: # normalLine
      # first dispatch comment_1/comment_2/string_1/string_2/directive
      whereIsComment_1 = index(restOfTheLine, "/*");
      whereIsComment_2 = index(restOfTheLine, "//");
      whereIsString_1 = index(restOfTheLine, "\"");
      whereIsString_2 = index(restOfTheLine, "'");
      if (testIt == "yes") {
        printf("whereIsComment_1= %d\n", whereIsComment_1);
        printf("whereIsComment_2= %d\n", whereIsComment_2);
        printf("whereIsString_1= %d\n", whereIsString_1);
        printf("whereIsString_2= %d\n", whereIsString_2);
      }
      # dispatch it
      if (whereIsComment_1 > 0) {
        # [1]
        if (testIt == "yes") {
          printf("switchState(97)(%d) changed to comment_1_BeginIsFound\n", NR);
        }
        switchState = comment_1_BeginIsFound;
        partBeforeComment = substr(restOfTheLine, 1, whereIsComment_1 - 1);
        if (testIt == "yes") {
          printf("(102)partBeforeComment >>%s<<\n", partBeforeComment);
        }
        workLine = workLine partBeforeComment;
        if (testIt == "yes") {
          printf("(106)workLine >>%s<<:\n", workLine);
        }
        temp = substr(restOfTheLine, whereIsComment_1 + 2);
        restOfTheLine = temp;
        lengthOfTheRest = length(restOfTheLine);
        if (testIt == "yes") {
          printf("%d:(112)restOfTheLine >>%s<<\n", NR, restOfTheLine);
        }
      } else {
        whereIsComment_2 = index(restOfTheLine, "//");
        if (testIt == "yes") {
          printf("whereIsComment_2= %d\n", whereIsComment_2);
        }
        if (whereIsComment_2 > 0) {
          # []
          if (testIt == "yes") {
            printf("switchState(122)(%d) changed to comment_2_BeginIsFound\n", NR);
          }
          switchState = comment_2_BeginIsFound;
          partBeforeComment = substr(restOfTheLine, 1, whereIsComment_2 - 1);
          # remove space(s) at end of the line
          partBefore = TrimLine(partBeforeComment);
          if (testIt == "yes") {
            printf("(129)partBeforeComment >>%s<<\n", partBeforeComment);
          }
          workLine = workLine partBeforeComment;
          if (testIt == "yes") {
            printf("(133)workLine >>%s<<:\n", workLine);
          }
        } else {
          whereIsString_1 = index(restOfTheLine, "\"");
          if (testIt == "yes") {
            printf("whereIsString_1= %d\n", whereIsString_1);
          }
          whereIsString_2 = index(restOfTheLine, "'");
          if (testIt == "yes") {
            printf("whereIsString_2= %d\n", whereIsString_2);
          }
          if ((whereIsString_1 > 0) && (whereIsString_2 > 0)) {
            if (testIt == "yes") {
              printf("choosing ...\n");
            }
            # check which one is first
            if (whereIsString_1 < whereIsString_2) {
              # whereIsString_1 is first
              whereIsString_2 = 0;
            } else {
              # whereIsString_2 is first
              whereIsString_1 = 0;
            }
          } else {
            # nothing to check
          }
          if (testIt == "yes") {
            printf("after choosing: whereIsString_1= %d\n", whereIsString_1);
          }
          if (testIt == "yes") {
            printf("after choosing: whereIsString_2= %d\n", whereIsString_2);
          }
          if (whereIsString_1 > 0) {
            # []
            if (testIt == "yes") {
              printf("switchState(168)(%d) changed to string_1_BeginIsFound\n", NR);
            }
            switchState = string_1_BeginIsFound;
            partBeforeString = substr(restOfTheLine, 1, whereIsString_1 - 1);
            if (testIt == "yes") {
              printf("(173)partBeforeString >>%s<<\n", partBeforeString);
            }
            workLine = workLine partBeforeString;
            if (testIt == "yes") {
              printf("(177)workLine >>%s<<:\n", workLine);
            }
            temp = substr(restOfTheLine, whereIsString_1 + 1);
            restOfTheLine = temp;
            lengthOfTheRest = length(restOfTheLine);
            if (testIt == "yes") {
              printf("%d:(183)restOfTheLine >>%s<<\n", NR, restOfTheLine);
            }
          } else {
            whereIsString_2 = index(restOfTheLine, "'");
            if (testIt == "yes") {
              printf("whereIsString_2= %d\n", whereIsString_2);
            }
            if (whereIsString_2 > 0) {
              # []
              if (testIt == "yes") {
                printf("switchState(193)(%d) changed to string_2_BeginIsFound\n", NR);
              }
              switchState = string_2_BeginIsFound;
              partBeforeString = substr(restOfTheLine, 1, whereIsString_2 - 1);
              if (testIt == "yes") {
                printf("(198)partBeforeString >>%s<<\n", partBeforeString);
              }
              workLine = workLine partBeforeString;
              if (testIt == "yes") {
                printf("(202)workLine >>%s<<:\n", workLine);
              }
              temp = substr(restOfTheLine, whereIsString_2 + 1);
              restOfTheLine = temp;
              lengthOfTheRest = length(restOfTheLine);
              if (testIt == "yes") {
                printf("%d:(208)restOfTheLine >>%s<<\n", NR, restOfTheLine);
              }
            } else {
              whereIsDirective = index(restOfTheLine, "#define ");
              if (testIt == "yes") {
                printf("whereIsDirective= %d\n", whereIsDirective);
              }
              if (whereIsDirective > 0) {
                # []
                if (testIt == "yes") {
                  printf("switchState(218)(%d) changed to directiveBeginIsFound\n", NR);
                }
                switchState = directiveBeginIsFound;
                temp = substr(restOfTheLine, whereIsDirective + 8);
                restOfTheLine = temp;
                lengthOfTheRest = length(restOfTheLine);
                if (testIt == "yes") {
                  printf("%d:(225)restOfTheLine >>%s<<\n", NR, restOfTheLine);
                }
              } else {
                # it is a normal line
                workLine = workLine restOfTheLine;
                # only for documentation: restOfTheLine = "";
                lengthOfTheRest = 0;
              }
            }
          }
        }
      }
      break;
    case 1: # comment_1_BeginIsFound
      if (testIt == "yes") {
        printf("%d:(240)restOfTheLine >>%s<<\n", NR, restOfTheLine);
      }
      # looking for */
      whereIsCommentEnd = index(restOfTheLine, "*/");
      if (whereIsCommentEnd > 0) {
        # [2]
        if (testIt == "yes") {
          printf("switchState(247)(%d) changed to comment_1_EndIsFound\n", NR);
        }
        switchState = comment_1_EndIsFound;
        # prepare the rest
        temp = substr(restOfTheLine, whereIsCommentEnd + 2);
        restOfTheLine = temp;
        if (testIt == "yes") {
          printf("(254)restOfTheLine >>%s<<\n", restOfTheLine);
        }
      } else {
        # no comment end found
        lengthOfTheRest = 0;
      }
      if (testIt == "yes") {
        printf("(261)workLine >>%s<<:\n", workLine);
      }
      break;
    case 2: # comment_1_EndIsFound
      if (testIt == "yes") {
        printf("(266)restOfTheLine >>%s<<\n", restOfTheLine);
      }
      lengthOfTheRest = length(restOfTheLine);
      if (testIt == "yes") {
        printf("switchState(270)(%d) changed to normalLine\n", NR);
      }
      switchState = normalLine;
      break;
    case 3: # comment_2_BeginIsFound
      # only for documentation: restOfTheLine = "";
      lengthOfTheRest = 0;
      if (testIt == "yes") {
        printf("switchState(278)(%d) changed to normalLine\n", NR);
      }
      switchState = normalLine;
      break;
    case 4: # string_1_BeginIsFound
      if (testIt == "yes") {
        printf("%d:(284)restOfTheLine >>%s<<\n", NR, restOfTheLine);
        printf("... looking for \"\n");
      }
      # looking for a closing "
      lengthOfTheRest = length(restOfTheLine);
      i = 1;
      EndIsFound = "no";
      while (i <= lengthOfTheRest && EndIsFound == "no") {
        character = substr(restOfTheLine, i, 1);
        if (testIt == "yes") {
          printf("look:i= %d, character=:%s:\n", i, character);
        }
        switch (character) {
        case "\"":
          if (testIt == "yes") {
            printf("found \"\n");
          }
            EndIsFound = "yes";
            whereIsStringEnd = i;
          break;
        case "\\":
          i = i + 1;
          if (testIt == "yes") {
            printf("found \\ escape character %d\n", i);
          }
          break;
        default:
          break;
        }
        i = i + 1;
      }
      if (testIt == "yes") {
        printf("%d:(316)whereIsStringEnd= %d\n", NR, whereIsStringEnd);
      }
      if (whereIsStringEnd > 0) {
        # []
        if (testIt == "yes") {
          printf("switchState(321)(%d) changed to string_1_EndIsFound\n", NR);
        }
        switchState = string_1_EndIsFound;
        # prepare the rest
        temp = substr(restOfTheLine, whereIsStringEnd + 1);
        restOfTheLine = temp;
        if (testIt == "yes") {
          printf("(328)restOfTheLine >>%s<<\n", restOfTheLine);
        }
      } else {
        # no string end found
        lengthOfTheRest = 0;
      }
      if (testIt == "yes") {
        printf("(335)workLine >>%s<<:\n", workLine);
      }
      break;
    case 5: # string_1_EndIsFound
      if (testIt == "yes") {
        printf("(340)restOfTheLine >>%s<<\n", restOfTheLine);
      }
      lengthOfTheRest = length(restOfTheLine);
      if (testIt == "yes") {
        printf("switchState(344)(%d) changed to normalLine\n", NR);
      }
      switchState = normalLine;
      break;
    case 6: # string_2_BeginIsFound
      if (testIt == "yes") {
        printf("%d:(350)restOfTheLine >>%s<<\n", NR, restOfTheLine);
      }
      # looking for closing '
      lengthOfTheRest = length(restOfTheLine);
      i = 1;
      EndIsFound = "no";
      while (i <= lengthOfTheRest && EndIsFound == "no") {
        character = substr(restOfTheLine, i, 1);
        if (testIt == "yes") {
          printf("look:i= %d, character=:%s:\n", i, character);
        }
        switch (character) {
        case "'":
          if (testIt == "yes") {
            printf("found '\n");
          }
            EndIsFound = "yes";
            whereIsStringEnd = i;
          break;
        case "\\":
          i = i + 1;
          if (testIt == "yes") {
            printf("found \\ escape character %d\n", i);
          }
          break;
        default:
          break;
        }
        i = i + 1;
      }
      if (testIt == "yes") {
        printf("%d:(381)whereIsStringEnd= %d\n", NR, whereIsStringEnd);
      }
      if (whereIsStringEnd > 0) {
        # []
        if (testIt == "yes") {
          printf("switchState(386)(%d) changed to string_2_EndIsFound\n", NR);
        }
        switchState = string_2_EndIsFound;
        # prepare the rest
        temp = substr(restOfTheLine, whereIsStringEnd + 1);
        restOfTheLine = temp;
        if (testIt == "yes") {
          printf("(393)restOfTheLine >>%s<<\n", restOfTheLine);
        }
      } else {
        # no string end found
        lengthOfTheRest = 0;
      }
      if (testIt == "yes") {
        printf("(400)workLine >>%s<<:\n", workLine);
      }
      break;
    case 7: # string_2_EndIsFound
      if (testIt == "yes") {
        printf("(405)restOfTheLine >>%s<<\n", restOfTheLine);
      }
      lengthOfTheRest = length(restOfTheLine);
      if (testIt == "yes") {
        printf("switchState(409)(%d) changed to normalLine\n", NR);
      }
      switchState = normalLine;
      break;
    case 8: # directiveBeginIsFound
      if (testIt == "yes") {
        printf("%d:(415)restOfTheLine >>%s<<\n", NR, restOfTheLine);
      }
      # looking for \ at the end of the line
      lengthOfTheRest = length(restOfTheLine);
      letter = substr(restOfTheLine, lengthOfTheRest, 1);
      if (letter != "\\") {
        # []
        if (testIt == "yes") {
          printf("switchState(423)(%d) changed to DirectiveEndIsFound\n", NR);
        }
        switchState = directiveEndIsFound;
      } else {
        # the directive goes on on the next line
        lengthOfTheRest = 0;
      }
      break;
    case 9: # directiveEndIsFound
      lengthOfTheRest = 0;
      switchState = normalLine;
      break;
    default:
      printf("(436) %d: WRONG VALUE for switchState= %d\n", NR, switchState);
      exit;
    } # switch(switchState)
  } # while (lengthOfTheRest > 0)
  if (testIt == "yes") {
    printf("(nach while)workLine >>%s<<\n", workLine);
  }

  # look for namespace xyz {
  if (testNS == "yes") {
    printf("(446) %d: namespaceWithBrace >%s<\n", NR, namespaceWithBrace);
  }
  if (namespaceWithBrace == "yes") {
    placeOfNamespace = index(workLine, "namespace" );
    if (testNS == "yes") {
      printf("(451) %d: placeOfNamespace= %d\n", NR, placeOfNamespace);
    }
    if (placeOfNamespace > 0) {
      placeOfUsing = index(workLine, "using namespace" );
      if (placeOfUsing == 0) {
        # look for last character of the line
        lengthOfTheLine = length(workLine);
        lastCharacter = substr(workLine, lengthOfTheLine, 1);
        if (lastCharacter != leftBrace) {
          namespaceWithBrace = "no";
          if (testNS == "yes") {
            printf("(462) %d: namespaceWithBrace set to >%s<\n", NR, namespaceWithBrace);
          }
          switch (mode) {
          case "check":
            if (testNS == "yes") {
              printf("(467) %d: EE ", NR);
            }
            printf("%d: namespace without leftBrace at end of line: %s\n", NR, theLine);
            break;
          case "change":
            break;
          }
          # look for leftBrace at the next line
          lineBefore = theLine;
        } else {
          # normal line "namespace xyz leftBrace"
          switch (mode) {
          case "check":
            break;
          case "change":
            if (testNS == "yes") {
              printf("(483) %d>>", NR);
            }
            printf("%s\n", theLine);
            break;
          }
        }
      } else {
        # normal line "using namespace xyz;"
        switch (mode) {
        case "check":
          break;
        case "change":
          if (testNS == "yes") {
            printf("(496) %d>>", NR);
          }
          printf("%s\n", theLine);
          break;
        }
      }
    } else {
      # normal line
      switch (mode) {
      case "check":
        break;
      case "change":
        if (testNS == "yes") {
          printf("(509) %d>>", NR);
        }
        printf("%s\n", theLine);
        break;
      }
    }
  } else {
    # we look for leftBrace at the next line
    firstCharacter = substr(workLine, 1, 1);
    if (firstCharacter == leftBrace) {
      switch (mode) {
      case "check":
        break;
      case "change":
        if (testNS == "yes") {
          printf("(524) %d>>", NR);
        }
        printf("%s %s\n", lineBefore, leftBrace);
        break;
      }
      namespaceWithBrace = "yes";
      if (testNS == "yes") {
        printf("(531) %d: namespaceWithBrace set to >%s<\n", NR, namespaceWithBrace);
      }
    } else {
      printf("This should never happens, as the source was compiled without error\n");
    }
  }
}
