BEGIN {
  switch (mode) {
  case "check":
    break;
  case "change":
    break;
  default:
    print "Public.awk: mode is not correct";
    print "it should be \"check\" or \"change\"";
    exit;
  }

  normalLine             = 0;
  comment_1_BeginIsFound = 1;
  comment_1_EndIsFound   = 2;
  comment_2_BeginIsFound = 3;
  string_1_BeginIsFound  = 4;
  string_1_EndIsFound    = 5;
  string_2_BeginIsFound  = 6;
  string_2_EndIsFound    = 7;
  directiveBeginIsFound  = 8;
  directiveEndIsFound    = 9;

  leftBrace  = "{";
  rightBrace = "}";

  switchState = normalLine;

  foundPart_2 = "no";
  numberOfBraces = 0;
  endOfQuestionStatementFound = "no";
  readTheNextLine = "yes";
  colonFound = "no";
  questionFound = "no";
  endOfInitializationFound = "no";
  # variable "doIt" may have one of these values: "no", "prepare" or "yes"
  doIt = "no";
  collectInitialization = "no";
  allTheInitializations = "";
  firstPart = "yes";

  # for debugging, set the following variable(s) to "yes"
  #testIt ="yes";
  #testOperator ="yes";
  #testSplit ="yes";
} # end of BEGIN

function Prot(lineNumber, message)
{
  if (testOperator == "yes") {
    printf("(%d) %d: %s", lineNumber, NR, message);
  }
}

function TrimLine(inLine,    lengthOfInLine, letter, tempBuffer)
{                            # separate local variables from real
                             # parameters  by  extra  spaces
  # remove space(s) at end of the line
  lengthOfInLine = length(inLine);
  letter = substr(inLine, lengthOfInLine, 1);
  while (letter == " ") {
    tempBuffer = substr(inLine, 1, lengthOfInLine - 1);
    inLine = tempBuffer;
    lengthOfInLine = length(inLine);
    letter = substr(inLine, lengthOfInLine, 1);
  }
  return inLine;
}

{ # do the job
  theLine = $0;
  if (testIt == "yes") {
    printf("(73) %d:\n", NR);
    printf("(74) %d: theLine >%s<\n", NR, theLine);
    printf("(75) %d: theLine >123456789=123456789=123456789=123456789=123456789=123456789=<\n", NR);
    printf("(76) %d: theLine >         1         2         3         4         5         6<\n", NR);
  }
  restOfTheLine = theLine;
  lengthOfTheRest = length(restOfTheLine);
  workLine = "";

  while (lengthOfTheRest > 0) {
    if (testIt == "yes") {
      printf("(84) %d: switchState= %d\n", NR, switchState);
      switch (switchState) {
      case 0: printf("(86) %d:     normalLine\n", NR); break;
      case 1: printf("(87) %d:     comment_1_BeginIsFound\n", NR); break;
      case 2: printf("(88) %d:     comment_1_EndIsFound\n", NR); break;
      case 3: printf("(89) %d:     comment_2_BeginIsFound\n", NR); break;
      case 4: printf("(90) %d:     string_1_BeginIsFound\n", NR); break;
      case 5: printf("(91) %d:     string_1_EndIsFound\n", NR); break;
      case 6: printf("(92) %d:     string_2_BeginIsFound\n", NR); break;
      case 7: printf("(93) %d:     string_2_EndIsFound\n", NR); break;
      case 8: printf("(94) %d:     directiveBeginIsFound\n", NR); break;
      case 9: printf("(95) %d:     directiveEndIsFound\n", NR); break;
      default:
        printf("(97) %d: WRONG VALUE for switchState= %d\n", NR, switchState);
        exit;
      }
    }
    switch (switchState) {
    case 0: # normalLine
      # first dispatch comment_1/comment_2/string_1/string_2/directive
      whereIsComment_1 = 0;
      whereIsComment_2 = 0;
      whereIsString_1 = 0;
      whereIsString_2 = 0;
      whereIsDirective = 0;
      foundPart_1 = "no";
      lengthOfTheRest = length(restOfTheLine);
      for (i = 1; i <= lengthOfTheRest; i++) {
        character = substr(restOfTheLine, i, 1);
        #if (testIt == "yes") {
        #  printf("(114) %d: look:i= %d, character >%s<\n", NR, i, character);
        #}
        switch (character) {
        case "/":
          if (testIt == "yes") {
            printf("(119) %d: found /\n", NR);
          }
          characterTwo = substr(restOfTheLine, i + 1, 1);
          if (testIt == "yes") {
            printf("(123) %d: characterTwo >%s<\n", NR, characterTwo);
          }
          switch (characterTwo) {
          case "/":
            if (testIt == "yes") {
              printf("(128) %d: found //\n", NR);
            }
            whereIsComment_2 = i;
            foundPart_1 = "yes";
            break;
          case "*":
            if (testIt == "yes") {
              printf("(135) %d: found /*\n", NR);
            }
            whereIsComment_1 = i;
            foundPart_1 = "yes";
            break;
          default:
            break;
          }
          break;
        case "\"":
          if (testIt == "yes") {
            printf("(146) %d: found \"\n", NR);
          }
          whereIsString_1 = i;
          foundPart_1 = "yes";
          break;
        case "'":
          if (testIt == "yes") {
            printf("(153) %d: found '\n", NR);
          }
          whereIsString_2 = i;
          foundPart_1 = "yes";
          break;
        case "#":
          if (testIt == "yes") {
            printf("(160) %d: found '\n", NR);
          }
          whereIsDirective = i;
          foundPart_1 = "yes";
          break;
        default:
          break;
        }
        if (foundPart_1 == "yes") {
           break; 
        }
      }
      if (testIt == "yes") {
        printf("(173) %d: whereIsComment_1= %d\n", NR, whereIsComment_1);
        printf("(174) %d: whereIsComment_2= %d\n", NR, whereIsComment_2);
        printf("(175) %d: whereIsString_1 = %d\n", NR, whereIsString_1);
        printf("(176) %d: whereIsString_2 = %d\n", NR, whereIsString_2);
        printf("(177) %d: whereIsDirective= %d\n", NR, whereIsDirective);
      }
      if (testIt == "yes") {
        printf("(180) %d: dispatch it\n", NR);
      }
      # dispatch it
      if (whereIsComment_1 > 0) {
        if (testIt == "yes") {
          printf("(185) %d: whereIsComment_1= %d\n", NR, whereIsComment_1);
        }
        # [1]
        if (testIt == "yes") {
          printf("(189) %d: switchState changed to comment_1_BeginIsFound\n", NR);
        }
        switchState = comment_1_BeginIsFound;
        partBeforeComment = substr(restOfTheLine, 1, whereIsComment_1 - 1);
        if (testIt == "yes") {
          printf("(194) %d: partBeforeComment >%s<\n", NR, partBeforeComment);
        }
        workLine = workLine partBeforeComment;
        if (testIt == "yes") {
          printf("(198) %d: workLine >%s<\n", NR, workLine);
        }
        temp = substr(restOfTheLine, whereIsComment_1 + 2);
        restOfTheLine = temp;
        lengthOfTheRest = length(restOfTheLine);
        if (testIt == "yes") {
          printf("(204) %d: restOfTheLine >%s<\n", NR, restOfTheLine);
        }
      } else {
        if (testIt == "yes") {
          printf("(208) %d: whereIsComment_2= %d\n", NR, whereIsComment_2);
        }
        if (whereIsComment_2 > 0) {
          # []
          if (testIt == "yes") {
            printf("(213) %d: switchState changed to comment_2_BeginIsFound\n", NR);
          }
          switchState = comment_2_BeginIsFound;
          partBeforeComment = substr(restOfTheLine, 1, whereIsComment_2 - 1);
          # remove space(s) at end of the line
          partBefore = TrimLine(partBeforeComment);
          if (testIt == "yes") {
            printf("(220) %d: partBeforeComment >%s<\n", NR, partBeforeComment);
          }
          workLine = workLine partBeforeComment;
          if (testIt == "yes") {
            printf("(224) %d: workLine >%s<\n", NR, workLine);
          }
        } else {
          if (whereIsString_1 > 0) {
            if (testIt == "yes") {
              printf("(229) %d: whereIsString_1= %d\n", NR, whereIsString_1);
            }
            # []
            if (testIt == "yes") {
              printf("(233) %d: switchState changed to string_1_BeginIsFound\n", NR);
            }
            switchState = string_1_BeginIsFound;
            partBeforeString = substr(restOfTheLine, 1, whereIsString_1 - 1);
            if (testIt == "yes") {
              printf("(238) %d: partBeforeString >%s<\n", NR, partBeforeString);
            }
            workLine = workLine partBeforeString;
            if (testIt == "yes") {
              printf("(242) %d: workLine >%s<\n", NR, workLine);
            }
            temp = substr(restOfTheLine, whereIsString_1 + 1);
            restOfTheLine = temp;
            lengthOfTheRest = length(restOfTheLine);
            if (testIt == "yes") {
              printf("(248) %d: restOfTheLine >%s<\n", NR, restOfTheLine);
            }
          } else {
            #whereIsString_2 = index(restOfTheLine, "'");
            if (testIt == "yes") {
              printf("(253) %d: whereIsString_2= %d\n", NR, whereIsString_2);
            }
            if (whereIsString_2 > 0) {
              # []
              if (testIt == "yes") {
                printf("(258) %d: switchState changed to string_2_BeginIsFound\n", NR);
              }
              switchState = string_2_BeginIsFound;
              partBeforeString = substr(restOfTheLine, 1, whereIsString_2 - 1);
              if (testIt == "yes") {
                printf("(263) %d: partBeforeString >%s<\n", NR, partBeforeString);
              }
              workLine = workLine partBeforeString;
              if (testIt == "yes") {
                printf("(267) %d: workLine >%s<\n", NR, workLine);
              }
              temp = substr(restOfTheLine, whereIsString_2 + 1);
              restOfTheLine = temp;
              lengthOfTheRest = length(restOfTheLine);
              if (testIt == "yes") {
                printf("(273) %d: restOfTheLine >%s<\n", NR, restOfTheLine);
              }
            } else {
              #whereIsDirective = index(restOfTheLine, "#define ");
              if (testIt == "yes") {
                printf("(278) %d: whereIsDirective= %d\n", NR, whereIsDirective);
              }
              if (whereIsDirective > 0) {
                # []
                if (testIt == "yes") {
                  printf("(283) %d: switchState changed to directiveBeginIsFound\n", NR);
                }
                switchState = directiveBeginIsFound;
                temp = substr(restOfTheLine, whereIsDirective + 8);
                restOfTheLine = temp;
                lengthOfTheRest = length(restOfTheLine);
                if (testIt == "yes") {
                  printf("(290) %d: restOfTheLine >%s<\n", NR, restOfTheLine);
                }
              } else {
                # it is a normal line
                workLine = workLine restOfTheLine;
                # only for documentation: restOfTheLine = "";
                lengthOfTheRest = 0;
              }
            }
          }
        }
      }
      break;
    case 1: # comment_1_BeginIsFound
      if (testIt == "yes") {
        printf("(305) %d: restOfTheLine >%s<\n", NR, restOfTheLine);
      }
      # looking for */
      whereIsCommentEnd = index(restOfTheLine, "*/");
      if (whereIsCommentEnd > 0) {
        # [2]
        if (testIt == "yes") {
          printf("(312) %d: switchState changed to comment_1_EndIsFound\n", NR);
        }
        switchState = comment_1_EndIsFound;
        # prepare the rest
        temp = substr(restOfTheLine, whereIsCommentEnd + 2);
        restOfTheLine = temp;
        if (testIt == "yes") {
          printf("(319) %d: restOfTheLine >%s<\n", NR, restOfTheLine);
        }
      } else {
        # no comment end found
        lengthOfTheRest = 0;
      }
      if (testIt == "yes") {
        printf("(326) %d: workLine >%s<\n", NR, workLine);
      }
      break;
    case 2: # comment_1_EndIsFound
      if (testIt == "yes") {
        printf("(331) %d: restOfTheLine >%s<\n", NR, restOfTheLine);
      }
      lengthOfTheRest = length(restOfTheLine);
      if (testIt == "yes") {
        printf("(335) %d: switchState changed to normalLine\n", NR);
      }
      switchState = normalLine;
      break;
    case 3: # comment_2_BeginIsFound
      # only for documentation: restOfTheLine = "";
      lengthOfTheRest = 0;
      if (testIt == "yes") {
        printf("(343) %d: switchState changed to normalLine\n", NR);
      }
      switchState = normalLine;
      break;
    case 4: # string_1_BeginIsFound
      if (testIt == "yes") {
        printf("(349) %d: restOfTheLine >%s<\n", NR, restOfTheLine);
        printf("(350) %d: ... looking for \"\n", NR);
      }
      # looking for a closing "
      lengthOfTheRest = length(restOfTheLine);
      i = 1;
      EndIsFound = "no";
      while (i <= lengthOfTheRest && EndIsFound == "no") {
        character = substr(restOfTheLine, i, 1);
        if (testIt == "yes") {
          printf("(359) %d: look:i= %d, character >%s<\n", NR, i, character);
        }
        switch (character) {
        case "\"":
          if (testIt == "yes") {
            printf("(364) %d: found \"\n", NR);
          }
            EndIsFound = "yes";
            whereIsStringEnd = i;
          break;
        case "\\":
          i = i + 1;
          if (testIt == "yes") {
            printf("(372) %d: found \\ escape character at %d\n", NR, i);
          }
          break;
        default:
          break;
        }
        i = i + 1;
      }
      if (testIt == "yes") {
        printf("(381) %d: whereIsStringEnd= %d\n", NR, whereIsStringEnd);
      }
      if (whereIsStringEnd > 0) {
        # []
        if (testIt == "yes") {
          printf("(386) %d: switchState changed to string_1_EndIsFound\n", NR);
        }
        switchState = string_1_EndIsFound;
        # prepare the rest
        temp = substr(restOfTheLine, whereIsStringEnd + 1);
        restOfTheLine = temp;
        if (testIt == "yes") {
          printf("(393) %d: restOfTheLine >%s<\n", NR, restOfTheLine);
        }
      } else {
        # no string end found
        lengthOfTheRest = 0;
      }
      if (testIt == "yes") {
        printf("(400) %d: workLine >%s<\n", NR, workLine);
      }
      break;
    case 5: # string_1_EndIsFound
      if (testIt == "yes") {
        printf("(405) %d: restOfTheLine >%s<\n", NR, restOfTheLine);
      }
      lengthOfTheRest = length(restOfTheLine);
      if (testIt == "yes") {
        printf("(409) %d: switchState changed to normalLine\n", NR);
      }
      switchState = normalLine;
      break;
    case 6: # string_2_BeginIsFound
      if (testIt == "yes") {
        printf("(415) %d: restOfTheLine >%s<\n", NR, restOfTheLine);
      }
      # looking for closing '
      lengthOfTheRest = length(restOfTheLine);
      i = 1;
      EndIsFound = "no";
      while (i <= lengthOfTheRest && EndIsFound == "no") {
        character = substr(restOfTheLine, i, 1);
        if (testIt == "yes") {
          printf("(424) %d: look:i= %d, character >%s<\n", NR, i, character);
        }
        switch (character) {
        case "'":
          if (testIt == "yes") {
            printf("(429) %d: found '\n", NR);
          }
            EndIsFound = "yes";
            whereIsStringEnd = i;
          break;
        case "\\":
          i = i + 1;
          if (testIt == "yes") {
            printf("(437) %d: found \\ escape character at %d\n", NR, i);
          }
          break;
        default:
          break;
        }
        i = i + 1;
      }
      if (testIt == "yes") {
        printf("(446) %d: whereIsStringEnd= %d\n", NR, whereIsStringEnd);
      }
      if (whereIsStringEnd > 0) {
        # []
        if (testIt == "yes") {
          printf("(451) %d: switchState changed to string_2_EndIsFound\n", NR);
        }
        switchState = string_2_EndIsFound;
        # prepare the rest
        temp = substr(restOfTheLine, whereIsStringEnd + 1);
        restOfTheLine = temp;
        if (testIt == "yes") {
          printf("(458) %d: restOfTheLine >%s<\n", NR, restOfTheLine);
        }
      } else {
        # no string end found
        lengthOfTheRest = 0;
      }
      if (testIt == "yes") {
        printf("(465) %d: workLine >%s<\n", NR, workLine);
      }
      break;
    case 7: # string_2_EndIsFound
      if (testIt == "yes") {
        printf("(470) %d: restOfTheLine >%s<\n", NR, restOfTheLine);
      }
      lengthOfTheRest = length(restOfTheLine);
      if (testIt == "yes") {
        printf("(474) %d: switchState changed to normalLine\n", NR);
      }
      switchState = normalLine;
      break;
    case 8: # directiveBeginIsFound
      if (testIt == "yes") {
        printf("(480) %d: restOfTheLine >%s<\n", NR, restOfTheLine);
      }
      # looking for \ at the end of the line
      lengthOfTheRest = length(restOfTheLine);
      letter = substr(restOfTheLine, lengthOfTheRest, 1);
      if (letter != "\\") {
        # []
        if (testIt == "yes") {
          printf("(488) %d: switchState changed to DirectiveEndIsFound\n", NR);
        }
        switchState = directiveEndIsFound;
      } else {
        # the directive goes on on the next line
        lengthOfTheRest = 0;
      }
      break;
    case 9: # directiveEndIsFound
      lengthOfTheRest = 0;
      switchState = normalLine;
      break;
    default:
      printf("(501) %d: WRONG VALUE for switchState= %d\n", NR, switchState);
      exit;
    } # switch (switchState)
  } # while (lengthOfTheRest > 0)
  if (testIt == "yes") {
    printf("(506) %d: (nach while)workLine >%s<\n", NR, workLine);
  }

  Prot((509), "\n");
  temp = sprintf("Input line >%s<\n", theLine);
  Prot((511), temp);
  Prot((512), "           >123456789=123456789=123456789=123456789=123456789=123456789=<\n");
  Prot((513), "           >         1         2         3         4         5         6<\n");
  whereIsOperatorSpace = index(workLine, "operator ");
  temp = sprintf("whereIsOperatorSpace >%d<\n", whereIsOperatorSpace);
  Prot((516), temp);
  if (whereIsOperatorSpace > 0) {
    switch (mode) {
    case "check":
      Prot((520), "EE\n");
      printf("%d: operator<SPACE> found >%s<\n", NR, theLine);
      printf("%d: <SPACE> after \"operator\" should be removed.\n", NR);
      break;
    case "change":
      sub("operator ", "operator", theLine);
      #temp =  sprintf(">>");
      #Prot((527), temp);
      #printf("%s\n", theLine);
      break;
    }
  }
  whereIsOperator = index(workLine, "operator");
  temp = sprintf("whereIsOperator >%d<\n", whereIsOperator);
  Prot((534), temp);
  if (whereIsOperator > 0) {
    # look after a space just after operator<operator>
    secondPart = substr(workLine, whereIsOperator + 8);
    temp = sprintf("secondPart >%s<\n", secondPart);
    Prot((539), temp);
    whereIsSpace = index(secondPart, " ");
    temp = sprintf("whereIsSpace >%d<\n", whereIsSpace);
    Prot((542), temp);
    if (whereIsSpace > 0 &&
        whereIsSpace <= 3) {
      switch (mode) {
      case "check":
        Prot((547), "EE\n");
        printf("%d: <SPACE> found after operator<operator> >%s<\n", NR, theLine);
        printf("%d: <SPACE> should be removed.\n", NR);
        break;
      case "change":
        temp =  sprintf(">>");
        Prot((553), temp);
        printf("%s\n", theLine);
        break;
      }
    } else {
      switch (mode) {
      case "check":
        break;
      case "change":
        temp =  sprintf(">>");
        Prot((563), temp);
        printf("%s\n", theLine);
        break;
      }
    }
  } else {
    switch (mode) {
    case "check":
      break;
    case "change":
      temp =  sprintf(">>");
      Prot((574), temp);
      printf("%s\n", theLine);
      break;
    }
  }
}
