BEGIN {
  if (mode != "check") {
    if (mode != "change") {
      print "twoBrace.awk: mode is not correct";
      print "it should be \"check\" or \"change\"";
      exit;
    }
  }

  normalLine             = 0;
  comment_1_BeginIsFound = 1;
  comment_1_EndIsFound   = 2;
  comment_2_BeginIsFound = 3;
  string_1_BeginIsFound  = 4;
  string_1_EndIsFound    = 5;
  string_2_BeginIsFound  = 6;
  string_2_EndIsFound    = 7;
  directiveBeginIsFound  = 8;
  directiveEndIsFound    = 9;

  leftBrace  = "{";
  rightBrace = "}";

  # for debugging, set the following variable(s) to "yes"
  #testIt ="no";
  #testTB ="no";
} # end of BEGIN

function Prot(lineNumber, message)
{
  if (testTB == "yes") {
    printf("(%d) %d: %s", lineNumber, NR, message);
  }
}

function TrimLine(inLine,    lengthOfInLine, letter, tempBuffer)
{                              # separate local variables from real  parameters  by  extra  spaces
  # remove space(s) at end of the line
  lengthOfInLine = length(inLine);
  letter = substr(inLine, lengthOfInLine, 1);
  while (letter == " ") {
    tempBuffer = substr(inLine, 1, lengthOfInLine - 1);
    inLine = tempBuffer;
    lengthOfInLine = length(inLine);
    letter = substr(inLine, lengthOfInLine, 1);
  }
  return inLine;
}

{ # do the job
  theLine = $0;
  if (testIt == "yes") {
    printf("\n%d, ====>:%s:\n", NR, theLine);
  }
  restOfTheLine = theLine;
  lengthOfTheRest = length(restOfTheLine);
  workLine = "";

  while (lengthOfTheRest > 0) {
    if (testIt == "yes") {
      printf("switchState(61)(%d)=%d\n", NR, switchState);
      switch (switchState) {
      case 0: printf("    normalLine\n"); break;
      case 1: printf("    comment_1_BeginIsFound\n"); break;
      case 2: printf("    comment_1_EndIsFound\n"); break;
      case 3: printf("    comment_2_BeginIsFound\n"); break;
      case 4: printf("    string_1_BeginIsFound\n"); break;
      case 5: printf("    string_1_EndIsFound\n"); break;
      case 6: printf("    string_2_BeginIsFound\n"); break;
      case 7: printf("    string_2_EndIsFound\n"); break;
      case 8: printf("    directiveBeginIsFound\n"); break;
      case 9: printf("    directiveEndIsFound\n"); break;
      }
    }
    switch(switchState) {
    case 0: # normalLine
      # first dispatch comment_1/comment_2/string_1/string_2/directive
      whereIsComment_1 = index(restOfTheLine, "/*");
      whereIsComment_2 = index(restOfTheLine, "//");
      whereIsString_1 = index(restOfTheLine, "\"");
      whereIsString_2 = index(restOfTheLine, "'");
      if (testIt == "yes") {
        printf("whereIsComment_1= %d\n", whereIsComment_1);
        printf("whereIsComment_2= %d\n", whereIsComment_2);
        printf("whereIsString_1= %d\n", whereIsString_1);
        printf("whereIsString_2= %d\n", whereIsString_2);
      }
      # dispatch it
      if (whereIsComment_1 > 0) {
        # [1]
        if (testIt == "yes") {
          printf("switchState(92)(%d) changed to comment_1_BeginIsFound\n", NR);
        }
        switchState = comment_1_BeginIsFound;
        partBeforeComment = substr(restOfTheLine, 1, whereIsComment_1 - 1);
        if (testIt == "yes") {
          printf("(97)partBeforeComment >%s<\n", partBeforeComment);
        }
        workLine = workLine partBeforeComment;
        if (testIt == "yes") {
          printf("(101)workLine >%s<:\n", workLine);
        }
        temp = substr(restOfTheLine, whereIsComment_1 + 2);
        restOfTheLine = temp;
        lengthOfTheRest = length(restOfTheLine);
        if (testIt == "yes") {
          printf("%d:(107)restOfTheLine >%s<\n", NR, restOfTheLine);
        }
      } else {
        whereIsComment_2 = index(restOfTheLine, "//");
        if (testIt == "yes") {
          printf("whereIsComment_2= %d\n", whereIsComment_2);
        }
        if (whereIsComment_2 > 0) {
          # []
          if (testIt == "yes") {
            printf("switchState(117)(%d) changed to comment_2_BeginIsFound\n", NR);
          }
          switchState = comment_2_BeginIsFound;
          partBeforeComment = substr(restOfTheLine, 1, whereIsComment_2 - 1);
          partBeforeComment = TrimLine(partBeforeComment);
          if (testIt == "yes") {
            printf("(123)partBeforeComment >%s<\n", partBeforeComment);
          }
          workLine = workLine partBeforeComment;
          if (testIt == "yes") {
            printf("(127)workLine >%s<:\n", workLine);
          }
        } else {
          whereIsString_1 = index(restOfTheLine, "\"");
          if (testIt == "yes") {
            printf("whereIsString_1= %d\n", whereIsString_1);
          }
          whereIsString_2 = index(restOfTheLine, "'");
          if (testIt == "yes") {
            printf("whereIsString_2= %d\n", whereIsString_2);
          }
          if ((whereIsString_1 > 0) && (whereIsString_2 > 0)) {
            if (testIt == "yes") {
              printf("choosing ...\n");
            }
            # check which one is first
            if (whereIsString_1 < whereIsString_2) {
              # whereIsString_1 is first
              whereIsString_2 = 0;
            } else {
              # whereIsString_2 is first
              whereIsString_1 = 0;
            }
          } else {
            # nothing to check
          }
          if (testIt == "yes") {
            printf("after choosing: whereIsString_1= %d\n", whereIsString_1);
          }
          if (testIt == "yes") {
            printf("after choosing: whereIsString_2= %d\n", whereIsString_2);
          }
          if (whereIsString_1 > 0) {
            # []
            if (testIt == "yes") {
              printf("switchState(162)(%d) changed to string_1_BeginIsFound\n", NR);
            }
            switchState = string_1_BeginIsFound;
            partBeforeString = substr(restOfTheLine, 1, whereIsString_1 - 1);
            if (testIt == "yes") {
              printf("(167)partBeforeString >%s<\n", partBeforeString);
            }
            workLine = workLine partBeforeString;
            if (testIt == "yes") {
              printf("(171)workLine >%s<:\n", workLine);
            }
            temp = substr(restOfTheLine, whereIsString_1 + 1);
            restOfTheLine = temp;
            lengthOfTheRest = length(restOfTheLine);
            if (testIt == "yes") {
              printf("%d:(177)restOfTheLine >%s<\n", NR, restOfTheLine);
            }
          } else {
            whereIsString_2 =  index(restOfTheLine, "'");
            if (testIt == "yes") {
              printf("whereIsString_2= %d\n",  whereIsString_2);
            }
            if (whereIsString_2 > 0) {
              # []
              if (testIt == "yes") {
                printf("switchState(187)(%d) changed to string_2_BeginIsFound\n", NR);
              }
              switchState = string_2_BeginIsFound;
              partBeforeString = substr(restOfTheLine, 1, whereIsString_2 - 1);
              if (testIt == "yes") {
                printf("(192)partBeforeString >%s<\n", partBeforeString);
              }
              workLine = workLine partBeforeString;
              if (testIt == "yes") {
                printf("(196)workLine >%s<:\n", workLine);
              }
              temp = substr(restOfTheLine, whereIsString_2 + 1);
              restOfTheLine = temp;
              lengthOfTheRest = length(restOfTheLine);
              if (testIt == "yes") {
                printf("%d:(202)restOfTheLine >%s<\n", NR, restOfTheLine);
              }
            } else {
              whereIsDirective = index(restOfTheLine, "#define ");
              if (testIt == "yes") {
                printf("whereIsDirective= %d\n", whereIsDirective);
              }
              if (whereIsDirective > 0) {
                # []
                if (testIt == "yes") {
                  printf("switchState(212)(%d) changed to directiveBeginIsFound\n", NR);
                }
                switchState = directiveBeginIsFound;
                temp = substr(restOfTheLine, whereIsDirective + 8);
                restOfTheLine = temp;
                lengthOfTheRest = length(restOfTheLine);
                if (testIt == "yes") {
                  printf("%d:(219)restOfTheLine >%s<\n", NR, restOfTheLine);
                }
              } else {
                # it is a normal line
                workLine = workLine restOfTheLine;
                # only for documentation: restOfTheLine = "";
                lengthOfTheRest = 0;
              }
            }
          }
        }
      }
      break;
    case 1: # comment_1_BeginIsFound
      if (testIt == "yes") {
        printf("%d:(234)restOfTheLine >%s<\n", NR, restOfTheLine);
      }
      # looking for */
      whereIsCommentEnd = index(restOfTheLine, "*/");
      if (whereIsCommentEnd > 0) {
        # [2]
        if (testIt == "yes") {
          printf("switchState(241)(%d) changed to comment_1_EndIsFound\n", NR);
        }
        switchState = comment_1_EndIsFound;
        # prepare the rest
        temp = substr(restOfTheLine, whereIsCommentEnd + 2);
        restOfTheLine = temp;
        if (testIt == "yes") {
          printf("(248)restOfTheLine >%s<\n", restOfTheLine);
        }
      } else {
        # no comment end found
        lengthOfTheRest = 0;
      }
      if (testIt == "yes") {
        printf("(255)workLine >%s<:\n", workLine);
      }
      break;
    case 2: # comment_1_EndIsFound
      if (testIt == "yes") {
        printf("(260)restOfTheLine >%s<\n", restOfTheLine);
      }
      lengthOfTheRest = length(restOfTheLine);
      if (testIt == "yes") {
        printf("switchState(264)(%d) changed to normalLine\n", NR);
      }
      switchState = normalLine;
      break;
    case 3: # comment_2_BeginIsFound
      # only for documentation: restOfTheLine = "";
      lengthOfTheRest = 0;
      if (testIt == "yes") {
        printf("switchState(272)(%d) changed to normalLine\n", NR);
      }
      switchState = normalLine;
      break;
    case 4: # string_1_BeginIsFound
      if (testIt == "yes") {
        printf("%d:(278)restOfTheLine >%s<\n", NR, restOfTheLine);
        printf("... looking for \"\n");
      }
      # looking for a closing "
      lengthOfTheRest = length(restOfTheLine);
      i = 1;
      EndIsFound = "no";
      while (i <= lengthOfTheRest && EndIsFound == "no") {
        character = substr(restOfTheLine, i, 1);
        if (testIt == "yes") {
          printf("look:i=%d, character=:%s:\n", i, character);
        }
        switch (character) {
        case "\"":
          if (testIt == "yes") {
            printf("found \"\n");
          }
            EndIsFound = "yes";
            whereIsStringEnd = i;
          break;
        case "\\":
          i = i + 1;
          if (testIt == "yes") {
            printf("found \\ escape character %d\n", i);
          }
          break;
        default:
          break;
        }
        i = i + 1;
      }
      if (testIt == "yes") {
        printf("%d:(310)whereIsStringEnd=%d\n", NR, whereIsStringEnd);
      }
      if (whereIsStringEnd > 0) {
        # []
        if (testIt == "yes") {
          printf("switchState(315)(%d) changed to string_1_EndIsFound\n", NR);
        }
        switchState = string_1_EndIsFound;
        # prepare the rest
        temp = substr(restOfTheLine, whereIsStringEnd + 1);
        restOfTheLine = temp;
        if (testIt == "yes") {
          printf("(322)restOfTheLine >%s<\n", restOfTheLine);
        }
      } else {
        # no string end found
        lengthOfTheRest = 0;
      }
      if (testIt == "yes") {
        printf("(329)workLine >%s<\n", workLine);
      }
      break;
    case 5: # string_1_EndIsFound
      if (testIt == "yes") {
        printf("(334)restOfTheLine >%s<\n", restOfTheLine);
      }
      lengthOfTheRest = length(restOfTheLine);
      if (testIt == "yes") {
        printf("switchState(338)(%d) changed to normalLine\n", NR);
      }
      switchState = normalLine;
      break;
    case 6: # string_2_BeginIsFound
      if (testIt == "yes") {
        printf("%d:(344)restOfTheLine >%s<\n", NR, restOfTheLine);
      }
      # looking for closing '
      lengthOfTheRest = length(restOfTheLine);
      i = 1;
      EndIsFound = "no";
      while (i <= lengthOfTheRest && EndIsFound == "no") {
        character = substr(restOfTheLine, i, 1);
        if (testIt == "yes") {
          printf("look:i=%d, character=:%s:\n", i, character);
        }
        switch (character) {
        case "'":
          if (testIt == "yes") {
            printf("found '\n");
          }
            EndIsFound = "yes";
            whereIsStringEnd = i;
          break;
        case "\\":
          i = i + 1;
          if (testIt == "yes") {
            printf("found \\ escape character %d\n", i);
          }
          break;
        default:
          break;
        }
        i = i + 1;
      }
      if (testIt == "yes") {
        printf("%d:(375)whereIsStringEnd=%d\n", NR, whereIsStringEnd);
      }
      if (whereIsStringEnd > 0) {
        # []
        if (testIt == "yes") {
          printf("switchState(380)(%d) changed to string_2_EndIsFound\n", NR);
        }
        switchState = string_2_EndIsFound;
        # prepare the rest
        temp = substr(restOfTheLine, whereIsStringEnd + 1);
        restOfTheLine = temp;
        if (testIt == "yes") {
          printf("(387)restOfTheLine >%s<\n", restOfTheLine);
        }
      } else {
        # no string end found
        lengthOfTheRest = 0;
      }
      if (testIt == "yes") {
        printf("(394)workLine >%s<:\n", workLine);
      }
      break;
    case 7: # string_2_EndIsFound
      if (testIt == "yes") {
        printf("(399)restOfTheLine >%s<\n", restOfTheLine);
      }
      lengthOfTheRest = length(restOfTheLine);
      if (testIt == "yes") {
        printf("switchState(403)(%d) changed to normalLine\n", NR);
      }
      switchState = normalLine;
      break;
    case 8: # directiveBeginIsFound
      if (testIt == "yes") {
        printf("%d:(409)restOfTheLine >%s<\n", NR, restOfTheLine);
      }
      # looking for \ at the end of the line
      lengthOfTheRest = length(restOfTheLine);
      letter = substr(restOfTheLine, lengthOfTheRest, 1);
      if (letter != "\\") {
        # []
        if (testIt == "yes") {
          printf("switchState(417)(%d) changed to DirectiveEndIsFound\n", NR);
        }
        switchState = directiveEndIsFound;
      } else {
        # the directive goes on on the next line
        lengthOfTheRest = 0;
      }
      break;
    case 9: # directiveEndIsFound
      lengthOfTheRest = 0;
      switchState = normalLine;
      break;
    default:
      printf("(430) %d: WRONG VALUE for switchState=%d\n", NR, switchState);
      exit;
    } # switch(switchState)
  } # while (lengthOfTheRest > 0)
  if (testIt == "yes") {
    printf("(nach while)workLine >%s<\n", workLine);
  }

  # looking for leftBrace rightBrace
  Prot((439), "\n");
  temp = sprintf("workLine >%s<\n", workLine);
  Prot((441), temp);
  temp = sprintf("look for TwoBrace\n");
  Prot((443), temp);
  temp = sprintf("look for leftBrace ... rightBrace in the same line\n");
  Prot((445), temp);
  # looking for leftBrace ... rightBrace in the same line
  whereIsLeftBrace = index(workLine, leftBrace);
  if (whereIsLeftBrace > 0) {
    temp = sprintf("leftBrace found\n");
    Prot((450), temp);
    restOfTheLine = substr(workLine, whereIsLeftBrace + 1);
    if (restOfTheLine == "") {
      Prot((453), "Rest of the Line is empty\n");
      switch (mode) {
      case "check":
        break;
      case "change":
        Prot((458), ">>");
        printf("%s\n", theLine);
        break;
      }
    } else {
      temp = sprintf("restOfTheLine >%s<\n", restOfTheLine);
      Prot((464), temp);
      temp = sprintf("look for rightBrace in the same line\n");
      Prot((466), temp);
      whereIsRightBrace = index(restOfTheLine, rightBrace);
      if (whereIsRightBrace > 0) {
        temp = sprintf("rightBrace found\n");
        Prot((470), temp);
        lengthOfRestOfTheLine = length(restOfTheLine);
        #lastLetter = substr(restOfTheLine, lengthOfRestOfTheLine, 1);
        #temp = sprintf("lastLetter >%s<\n", lastLetter);
        #Prot((474), temp);
        #if (lastLetter != ";") {
          temp = sprintf("rightBrace in the same line found\n");
          Prot((477), temp);
          temp = sprintf("leftBrace ... rightBrace in the same line found\n");
          Prot((479), temp);
          temp = sprintf("let have a look to the beginnig of the line\n");
          Prot((481), temp);
          temp = sprintf("leftBrace found at %d\n", whereIsLeftBrace);
          Prot((483), temp);
          if (mode == "check") {
            printf("%d: leftBrace ... rightBrace in the same line found: %s\n", NR, theLine);
          }
          temp = substr(theLine, 1, whereIsLeftBrace - 1);
          partAtTheBegin = TrimLine(temp);
          lengthOfThePart = length(partAtTheBegin);
          temp = sprintf("lengthOfThePart %d\n", lengthOfThePart);
          Prot((491), temp);
          if (lengthOfThePart == 0) {
            temp = sprintf("In the part before there are only space(s): don't do anything.\n");
            Prot((494), temp);
            if (mode == "change") {
              printf("%s\n", theLine);
            }
          } else {
            if (mode == "check") {
              printf("%d: leftBrace ... rightBrace in the same line found: %s\n", NR, theLine);
            }
            if (mode == "change") {
              Prot((503), ">>");
              temp = sprintf("leftBrace ... rightBrace: there are many changes to do: %s\n", theLine);
              Prot((505), temp);
              whereIsLeftBrace2 = index(theLine, leftBrace);
              temp = sprintf("whereIsLeftBrace2>%d<\n", whereIsLeftBrace2);
              Prot((508), temp);
              temp = substr(theLine, 1, whereIsLeftBrace - 1);
              # remove space(s) at end of the line
              thePartBefore = TrimLine(temp);
              temp = sprintf("thePartBefore>%s<\n", thePartBefore);
              Prot((513), temp);
              temp = sprintf("restOfTheLine>%s<\n", restOfTheLine);
              Prot((515), temp);
              temp = substr(restOfTheLine, 1, whereIsRightBrace - 1);
              # remove space(s) at end of the line
              thePartInTheMiddle = TrimLine(temp);
              lengthOfTheMiddle = length(thePartInTheMiddle);
              temp = sprintf("thePartInTheMiddle>%s<\n", thePartInTheMiddle);
              Prot((521), temp);
              temp = substr(restOfTheLine, whereIsRightBrace + 1);
              # remove space(s) at end of the line
              lastPartOfTheLine = TrimLine(temp);
              lengthOfTheLastPart = length(lastPartOfTheLine);
              temp = sprintf("lastPartOfTheLine>%s<\n", lastPartOfTheLine);
              Prot((527), temp);
              Prot((528), ">>");
              printf("%s\n", thePartBefore);
              Prot((530), ">>");
              printf("  {\n");
              # if there are more than one part, these would be changed by astyle
              if (lengthOfTheMiddle > 0) {
                Prot((534), ">>");
                printf("    %s\n", thePartInTheMiddle);
              }
              Prot((537), ">>");
              printf("  }\n");
              if (lengthOfTheLastPart > 0) {
                Prot((540), ">>");
                printf("  %s\n", lastPartOfTheLine);
              }
            }
          }
        #}
      } else {
        switch (mode) {
        case "check":
          break;
        case "change":
          temp = sprintf("A: ");
          Prot((552), temp);
          printf("%s\n", theLine);
          break;
        }
      }
    }
  } else {
    temp = sprintf("leftBrace ... rightBrace in the same line not found\n"); 
    Prot((560), temp);
    switch (mode) {
    case "check":
      break;
    case "change":
      Prot((565), ">>");
      printf("%s\n", theLine);
      break;
    }
  }
}
